
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         sparql_parser_parse
#define yylex           sparql_parser_lex
#define yyerror         sparql_parser_error
#define yylval          sparql_parser_lval
#define yychar          sparql_parser_char
#define yydebug         sparql_parser_debug
#define yynerrs         sparql_parser_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 28 "./sparql_parser.y"

#ifdef HAVE_CONFIG_H
#include <rasqal_config.h>
#endif

#ifdef WIN32
#include <win32_rasqal_config.h>
#endif

#include <stdio.h>
#include <stdarg.h>

#include <rasqal.h>
#include <rasqal_internal.h>

#include <sparql_parser.h>

#define YY_DECL int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t yyscanner)
#define YY_NO_UNISTD_H 1
#include <sparql_lexer.h>

#include <sparql_common.h>


#if 0
#undef RASQAL_DEBUG
#define RASQAL_DEBUG 3
#endif


#define DEBUG_FH stderr

/* Make verbose error messages for syntax errors */
#define YYERROR_VERBOSE 1

/* Fail with an debug error message if RASQAL_DEBUG > 1 */
#if RASQAL_DEBUG > 1
#define YYERROR_MSG(msg) do { fputs("** YYERROR ", DEBUG_FH); fputs(msg, DEBUG_FH); fputc('\n', DEBUG_FH); YYERROR; } while(0)
#else
#define YYERROR_MSG(ignore) YYERROR
#endif

/* Slow down the grammar operation and watch it work */
#if RASQAL_DEBUG > 2
#define YYDEBUG 1
#endif

/* the lexer does not seem to track this */
#undef RASQAL_SPARQL_USE_ERROR_COLUMNS

/* Missing sparql_lexer.c/h prototypes */
int sparql_lexer_get_column(yyscan_t yyscanner);
/* Not used here */
/* void sparql_lexer_set_column(int  column_no , yyscan_t yyscanner);*/


/* What the lexer wants */
extern int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t scanner);
#define YYLEX_PARAM ((rasqal_sparql_query_language*)(((rasqal_query*)rq)->context))->scanner

/* Pure parser argument (a void*) */
#define YYPARSE_PARAM rq

/* Make the yyerror below use the rdf_parser */
#undef yyerror
#define yyerror(message) sparql_query_error((rasqal_query*)rq, message)

/* Make lex/yacc interface as small as possible */
#undef yylex
#define yylex sparql_lexer_lex


static int sparql_parse(rasqal_query* rq);
static void sparql_query_error(rasqal_query* rq, const char *message);
static void sparql_query_error_full(rasqal_query *rq, const char *message, ...) RASQAL_PRINTF_FORMAT(2, 3);

static sparql_uri_applies*
new_uri_applies(raptor_uri* uri, rasqal_update_graph_applies applies) 
{
  sparql_uri_applies* ua;
  ua = (sparql_uri_applies*)RASQAL_MALLOC(uri_applies, sizeof(*ua));
  if(!ua)
    return NULL;
  
  ua->uri = uri;
  ua->applies = applies;

  return ua;
}


static void
free_uri_applies(sparql_uri_applies* ua)
{
  if(ua->uri)
    raptor_free_uri(ua->uri);
}





/* Line 189 of yacc.c  */
#line 184 "sparql_parser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SELECT = 258,
     FROM = 259,
     WHERE = 260,
     OPTIONAL = 261,
     DESCRIBE = 262,
     CONSTRUCT = 263,
     ASK = 264,
     DISTINCT = 265,
     REDUCED = 266,
     LIMIT = 267,
     UNION = 268,
     PREFIX = 269,
     BASE = 270,
     BOUND = 271,
     GRAPH = 272,
     NAMED = 273,
     FILTER = 274,
     OFFSET = 275,
     ORDER = 276,
     BY = 277,
     REGEX = 278,
     ASC = 279,
     DESC = 280,
     LANGMATCHES = 281,
     A = 282,
     STRLANG = 283,
     STRDT = 284,
     STR = 285,
     IRI = 286,
     URI = 287,
     BNODE = 288,
     LANG = 289,
     DATATYPE = 290,
     ISURI = 291,
     ISBLANK = 292,
     ISLITERAL = 293,
     ISNUMERIC = 294,
     SAMETERM = 295,
     GROUP = 296,
     HAVING = 297,
     COUNT = 298,
     SUM = 299,
     AVG = 300,
     MIN = 301,
     MAX = 302,
     GROUP_CONCAT = 303,
     SAMPLE = 304,
     SEPARATOR = 305,
     DELETE = 306,
     INSERT = 307,
     WITH = 308,
     CLEAR = 309,
     CREATE = 310,
     SILENT = 311,
     DATA = 312,
     DROP = 313,
     LOAD = 314,
     INTO = 315,
     DEFAULT = 316,
     TO = 317,
     ADD = 318,
     MOVE = 319,
     COPY = 320,
     ALL = 321,
     COALESCE = 322,
     AS = 323,
     IF = 324,
     NOT = 325,
     IN = 326,
     BINDINGS = 327,
     UNDEF = 328,
     SERVICE = 329,
     MINUS = 330,
     YEAR = 331,
     MONTH = 332,
     DAY = 333,
     HOURS = 334,
     MINUTES = 335,
     SECONDS = 336,
     TIMEZONE = 337,
     TZ = 338,
     STRLEN = 339,
     SUBSTR = 340,
     UCASE = 341,
     LCASE = 342,
     STRSTARTS = 343,
     STRENDS = 344,
     CONTAINS = 345,
     ENCODE_FOR_URI = 346,
     CONCAT = 347,
     BIND = 348,
     ABS = 349,
     ROUND = 350,
     CEIL = 351,
     FLOOR = 352,
     RAND = 353,
     MD5 = 354,
     SHA1 = 355,
     SHA224 = 356,
     SHA256 = 357,
     SHA384 = 358,
     SHA512 = 359,
     EXPLAIN = 360,
     LET = 361,
     CURRENT_DATETIME = 362,
     NOW = 363,
     FROM_UNIXTIME = 364,
     TO_UNIXTIME = 365,
     HATHAT = 366,
     SC_OR = 367,
     SC_AND = 368,
     EQ = 369,
     NEQ = 370,
     LT = 371,
     GT = 372,
     LE = 373,
     GE = 374,
     ASSIGN = 375,
     STRING = 376,
     LANG_TAG = 377,
     DOUBLE_LITERAL = 378,
     DOUBLE_POSITIVE_LITERAL = 379,
     DOUBLE_NEGATIVE_LITERAL = 380,
     INTEGER_LITERAL = 381,
     INTEGER_POSITIVE_LITERAL = 382,
     INTEGER_NEGATIVE_LITERAL = 383,
     DECIMAL_LITERAL = 384,
     DECIMAL_POSITIVE_LITERAL = 385,
     DECIMAL_NEGATIVE_LITERAL = 386,
     BOOLEAN_LITERAL = 387,
     URI_LITERAL = 388,
     URI_LITERAL_BRACE = 389,
     QNAME_LITERAL = 390,
     QNAME_LITERAL_BRACE = 391,
     BLANK_LITERAL = 392,
     IDENTIFIER = 393
   };
#endif
/* Tokens.  */
#define SELECT 258
#define FROM 259
#define WHERE 260
#define OPTIONAL 261
#define DESCRIBE 262
#define CONSTRUCT 263
#define ASK 264
#define DISTINCT 265
#define REDUCED 266
#define LIMIT 267
#define UNION 268
#define PREFIX 269
#define BASE 270
#define BOUND 271
#define GRAPH 272
#define NAMED 273
#define FILTER 274
#define OFFSET 275
#define ORDER 276
#define BY 277
#define REGEX 278
#define ASC 279
#define DESC 280
#define LANGMATCHES 281
#define A 282
#define STRLANG 283
#define STRDT 284
#define STR 285
#define IRI 286
#define URI 287
#define BNODE 288
#define LANG 289
#define DATATYPE 290
#define ISURI 291
#define ISBLANK 292
#define ISLITERAL 293
#define ISNUMERIC 294
#define SAMETERM 295
#define GROUP 296
#define HAVING 297
#define COUNT 298
#define SUM 299
#define AVG 300
#define MIN 301
#define MAX 302
#define GROUP_CONCAT 303
#define SAMPLE 304
#define SEPARATOR 305
#define DELETE 306
#define INSERT 307
#define WITH 308
#define CLEAR 309
#define CREATE 310
#define SILENT 311
#define DATA 312
#define DROP 313
#define LOAD 314
#define INTO 315
#define DEFAULT 316
#define TO 317
#define ADD 318
#define MOVE 319
#define COPY 320
#define ALL 321
#define COALESCE 322
#define AS 323
#define IF 324
#define NOT 325
#define IN 326
#define BINDINGS 327
#define UNDEF 328
#define SERVICE 329
#define MINUS 330
#define YEAR 331
#define MONTH 332
#define DAY 333
#define HOURS 334
#define MINUTES 335
#define SECONDS 336
#define TIMEZONE 337
#define TZ 338
#define STRLEN 339
#define SUBSTR 340
#define UCASE 341
#define LCASE 342
#define STRSTARTS 343
#define STRENDS 344
#define CONTAINS 345
#define ENCODE_FOR_URI 346
#define CONCAT 347
#define BIND 348
#define ABS 349
#define ROUND 350
#define CEIL 351
#define FLOOR 352
#define RAND 353
#define MD5 354
#define SHA1 355
#define SHA224 356
#define SHA256 357
#define SHA384 358
#define SHA512 359
#define EXPLAIN 360
#define LET 361
#define CURRENT_DATETIME 362
#define NOW 363
#define FROM_UNIXTIME 364
#define TO_UNIXTIME 365
#define HATHAT 366
#define SC_OR 367
#define SC_AND 368
#define EQ 369
#define NEQ 370
#define LT 371
#define GT 372
#define LE 373
#define GE 374
#define ASSIGN 375
#define STRING 376
#define LANG_TAG 377
#define DOUBLE_LITERAL 378
#define DOUBLE_POSITIVE_LITERAL 379
#define DOUBLE_NEGATIVE_LITERAL 380
#define INTEGER_LITERAL 381
#define INTEGER_POSITIVE_LITERAL 382
#define INTEGER_NEGATIVE_LITERAL 383
#define DECIMAL_LITERAL 384
#define DECIMAL_POSITIVE_LITERAL 385
#define DECIMAL_NEGATIVE_LITERAL 386
#define BOOLEAN_LITERAL 387
#define URI_LITERAL 388
#define URI_LITERAL_BRACE 389
#define QNAME_LITERAL 390
#define QNAME_LITERAL_BRACE 391
#define BLANK_LITERAL 392
#define IDENTIFIER 393




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 138 "./sparql_parser.y"

  raptor_sequence *seq;
  rasqal_variable *variable;
  rasqal_literal *literal;
  rasqal_triple *triple;
  rasqal_expression *expr;
  rasqal_graph_pattern *graph_pattern;
  double floating;
  raptor_uri *uri;
  unsigned char *name;
  rasqal_formula *formula;
  rasqal_update_operation *update;
  unsigned int uinteger;
  rasqal_data_graph* data_graph;
  rasqal_row* row;
  rasqal_solution_modifier* modifier;
  int limit_offset[2];
  int integer;
  rasqal_projection* projection;
  rasqal_bindings* bindings;
  sparql_uri_applies* uri_applies;



/* Line 214 of yacc.c  */
#line 521 "sparql_parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 533 "sparql_parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  8
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2116

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  155
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  150
/* YYNRULES -- Number of rules.  */
#define YYNRULES  374
/* YYNRULES -- Number of states.  */
#define YYNSTATES  758

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   393

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   154,     2,     2,   119,     2,     2,     2,
     112,   113,   131,   129,   111,   130,   153,   132,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   152,
       2,     2,     2,   118,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   114,     2,   115,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   116,     2,   117,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    12,    14,    15,    17,    19,
      21,    23,    27,    30,    32,    33,    35,    37,    39,    41,
      43,    45,    47,    49,    51,    53,    56,    59,    60,    65,
      66,    71,    75,    79,    83,    86,    88,    90,    93,    97,
      99,   101,   107,   109,   111,   113,   115,   117,   119,   121,
     123,   124,   126,   128,   134,   140,   146,   152,   158,   163,
     164,   168,   170,   177,   183,   189,   195,   201,   204,   208,
     210,   214,   217,   220,   223,   227,   233,   239,   243,   245,
     251,   257,   259,   261,   264,   266,   270,   276,   282,   294,
     302,   310,   318,   320,   322,   324,   326,   329,   333,   335,
     337,   338,   342,   346,   350,   353,   355,   357,   359,   361,
     363,   365,   369,   375,   381,   387,   393,   396,   398,   400,
     401,   403,   406,   408,   411,   413,   415,   416,   421,   424,
     426,   429,   430,   432,   434,   439,   441,   445,   446,   448,
     451,   453,   456,   457,   460,   463,   465,   467,   468,   472,
     473,   476,   478,   481,   484,   486,   488,   490,   492,   495,
     498,   504,   505,   508,   510,   512,   513,   516,   518,   522,
     525,   528,   530,   532,   535,   539,   541,   543,   545,   547,
     549,   553,   557,   560,   562,   563,   566,   568,   569,   573,
     575,   577,   579,   580,   584,   586,   588,   590,   592,   594,
     596,   598,   600,   603,   607,   611,   614,   618,   620,   624,
     626,   633,   640,   643,   645,   647,   649,   651,   652,   659,
     663,   666,   670,   674,   676,   677,   681,   683,   684,   688,
     690,   693,   696,   700,   703,   704,   706,   707,   710,   713,
     714,   716,   718,   720,   722,   724,   728,   732,   735,   737,
     739,   741,   743,   745,   747,   749,   752,   755,   757,   760,
     763,   765,   767,   769,   771,   773,   775,   778,   780,   784,
     786,   790,   792,   796,   800,   804,   808,   812,   816,   820,
     825,   827,   831,   835,   838,   841,   843,   847,   851,   853,
     856,   859,   862,   864,   866,   868,   870,   872,   874,   876,
     880,   885,   890,   897,   902,   907,   912,   917,   922,   926,
     930,   935,   940,   945,   950,   955,   960,   965,   970,   975,
     980,   982,   984,   993,  1000,  1007,  1014,  1019,  1024,  1029,
    1034,  1036,  1038,  1040,  1045,  1052,  1061,  1066,  1071,  1078,
    1085,  1092,  1097,  1102,  1109,  1118,  1123,  1128,  1133,  1138,
    1143,  1148,  1153,  1158,  1162,  1166,  1171,  1176,  1178,  1180,
    1182,  1184,  1186,  1188,  1190,  1192,  1194,  1196,  1198,  1200,
    1202,  1204,  1206,  1208,  1210
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     156,     0,    -1,   157,    -1,   160,    -1,   163,   158,   159,
     230,    -1,   105,    -1,    -1,   166,    -1,   184,    -1,   185,
      -1,   187,    -1,   163,   162,   161,    -1,   152,   160,    -1,
     152,    -1,    -1,   190,    -1,   195,    -1,   196,    -1,   198,
      -1,   200,    -1,   201,    -1,   205,    -1,   206,    -1,   207,
      -1,   208,    -1,   164,   165,    -1,    15,   146,    -1,    -1,
     165,    14,   151,   146,    -1,    -1,   168,   210,   214,   216,
      -1,   168,   214,   216,    -1,     3,    10,   169,    -1,     3,
      11,   169,    -1,     3,   169,    -1,   170,    -1,   131,    -1,
     170,   171,    -1,   170,   111,   171,    -1,   171,    -1,   280,
      -1,   112,   284,    68,   282,   113,    -1,   175,    -1,   176,
      -1,   177,    -1,   178,    -1,   179,    -1,   182,    -1,   183,
      -1,    10,    -1,    -1,   284,    -1,   131,    -1,    43,   112,
     173,   174,   113,    -1,    44,   112,   173,   284,   113,    -1,
      45,   112,   173,   284,   113,    -1,    46,   112,   173,   284,
     113,    -1,    47,   112,   173,   284,   113,    -1,   152,    50,
     123,   134,    -1,    -1,   181,   111,   284,    -1,   284,    -1,
      48,   112,   173,   181,   180,   113,    -1,    49,   112,   173,
     284,   113,    -1,     8,   262,   210,   214,   216,    -1,     7,
     186,   210,   215,   216,    -1,     7,   131,   210,   215,   216,
      -1,   186,   279,    -1,   186,   111,   279,    -1,   279,    -1,
       9,   210,   214,    -1,     4,   211,    -1,     4,   212,    -1,
      17,   146,    -1,    51,   209,   215,    -1,    51,   116,   194,
     117,   214,    -1,    51,    57,   116,   191,   117,    -1,    51,
       5,   238,    -1,   245,    -1,    17,   146,   116,   245,   117,
      -1,    17,   279,   116,   264,   117,    -1,   264,    -1,   192,
      -1,   194,   193,    -1,   193,    -1,    52,   209,   215,    -1,
      52,   116,   194,   117,   215,    -1,    52,    57,   116,   191,
     117,    -1,    53,   146,    51,   116,   194,   117,    52,   116,
     194,   117,   215,    -1,    53,   146,    51,   116,   194,   117,
     215,    -1,    53,   146,    52,   116,   194,   117,   215,    -1,
      53,   146,    52,    57,   116,   191,   117,    -1,   189,    -1,
      61,    -1,    18,    -1,    66,    -1,    17,    61,    -1,    54,
     199,   197,    -1,    54,    -1,    56,    -1,    -1,    55,   199,
     146,    -1,    55,   199,   189,    -1,    58,   199,   197,    -1,
     202,   146,    -1,   146,    -1,    61,    -1,   146,    -1,   189,
      -1,   146,    -1,    61,    -1,    59,   199,   146,    -1,    59,
     199,   202,    60,   204,    -1,    63,   199,   203,    62,   203,
      -1,    64,   199,   203,    62,   203,    -1,    65,   199,   203,
      62,   203,    -1,   209,   188,    -1,   188,    -1,   209,    -1,
      -1,   213,    -1,    18,   213,    -1,   303,    -1,     5,   238,
      -1,   238,    -1,   214,    -1,    -1,   220,   223,   225,   224,
      -1,   217,   219,    -1,   219,    -1,    68,   280,    -1,    -1,
     293,    -1,   258,    -1,   112,   284,   218,   113,    -1,   280,
      -1,    41,    22,   217,    -1,    -1,   256,    -1,   222,   221,
      -1,   221,    -1,    42,   222,    -1,    -1,   228,   229,    -1,
     229,   228,    -1,   228,    -1,   229,    -1,    -1,    21,    22,
     226,    -1,    -1,   226,   227,    -1,   227,    -1,    24,   292,
      -1,    25,   292,    -1,   258,    -1,   280,    -1,   292,    -1,
     293,    -1,    12,   139,    -1,    20,   139,    -1,    72,   231,
     116,   232,   117,    -1,    -1,   231,   280,    -1,   280,    -1,
     233,    -1,    -1,   233,   234,    -1,   234,    -1,   112,   235,
     113,    -1,   112,   113,    -1,   235,   237,    -1,   237,    -1,
     134,    -1,   134,   135,    -1,   134,   120,   303,    -1,   303,
      -1,   236,    -1,   299,    -1,   145,    -1,    73,    -1,   116,
     167,   117,    -1,   116,   239,   117,    -1,   240,   241,    -1,
     245,    -1,    -1,   241,   242,    -1,   242,    -1,    -1,   243,
     244,   240,    -1,   246,    -1,   255,    -1,   153,    -1,    -1,
     265,   153,   240,    -1,   265,    -1,   251,    -1,   247,    -1,
     250,    -1,   248,    -1,   249,    -1,   253,    -1,   254,    -1,
       6,   238,    -1,    17,   279,   238,    -1,    74,   279,   238,
      -1,    75,   238,    -1,   238,    13,   252,    -1,   238,    -1,
     252,    13,   238,    -1,   238,    -1,   106,   112,   280,   133,
     284,   113,    -1,    93,   112,   284,    68,   280,   113,    -1,
      19,   256,    -1,   292,    -1,   293,    -1,   258,    -1,   152,
      -1,    -1,   303,   112,   173,   261,   257,   113,    -1,   298,
     261,   113,    -1,    67,   260,    -1,   112,   261,   113,    -1,
     261,   111,   284,    -1,   284,    -1,    -1,   116,   263,   117,
      -1,   264,    -1,    -1,   265,   153,   263,    -1,   265,    -1,
     278,   266,    -1,   273,   268,    -1,   272,   269,   267,    -1,
     152,   268,    -1,    -1,   266,    -1,    -1,   271,   270,    -1,
     111,   269,    -1,    -1,   277,    -1,   279,    -1,    27,    -1,
     275,    -1,   274,    -1,   114,   266,   115,    -1,   112,   276,
     113,    -1,   276,   277,    -1,   277,    -1,   278,    -1,   273,
      -1,   280,    -1,   283,    -1,   280,    -1,   303,    -1,   118,
     281,    -1,   119,   281,    -1,   151,    -1,   118,   281,    -1,
     119,   281,    -1,   281,    -1,   303,    -1,   236,    -1,   299,
      -1,   145,    -1,   304,    -1,   112,   113,    -1,   285,    -1,
     285,   121,   286,    -1,   286,    -1,   286,   122,   287,    -1,
     287,    -1,   288,   123,   288,    -1,   288,   124,   288,    -1,
     288,   125,   288,    -1,   288,   126,   288,    -1,   288,   127,
     288,    -1,   288,   128,   288,    -1,   288,    71,   260,    -1,
     288,    70,    71,   260,    -1,   288,    -1,   289,   129,   288,
      -1,   289,   130,   288,    -1,   289,   301,    -1,   289,   302,
      -1,   289,    -1,   290,   131,   289,    -1,   290,   132,   289,
      -1,   290,    -1,   154,   291,    -1,   129,   291,    -1,   130,
     291,    -1,   291,    -1,   292,    -1,   293,    -1,   258,    -1,
     283,    -1,   280,    -1,   172,    -1,   112,   284,   113,    -1,
      30,   112,   284,   113,    -1,    34,   112,   284,   113,    -1,
      26,   112,   284,   111,   284,   113,    -1,    35,   112,   284,
     113,    -1,    16,   112,   280,   113,    -1,    31,   112,   284,
     113,    -1,    32,   112,   284,   113,    -1,    33,   112,   284,
     113,    -1,    33,   112,   113,    -1,    98,   112,   113,    -1,
      94,   112,   284,   113,    -1,    96,   112,   284,   113,    -1,
      97,   112,   284,   113,    -1,    95,   112,   284,   113,    -1,
      99,   112,   284,   113,    -1,   100,   112,   284,   113,    -1,
     101,   112,   284,   113,    -1,   102,   112,   284,   113,    -1,
     103,   112,   284,   113,    -1,   104,   112,   284,   113,    -1,
     294,    -1,   259,    -1,    69,   112,   284,   111,   284,   111,
     284,   113,    -1,    28,   112,   284,   111,   284,   113,    -1,
      29,   112,   284,   111,   284,   113,    -1,    40,   112,   284,
     111,   284,   113,    -1,    36,   112,   284,   113,    -1,    37,
     112,   284,   113,    -1,    38,   112,   284,   113,    -1,    39,
     112,   284,   113,    -1,   295,    -1,   296,    -1,   297,    -1,
      84,   112,   284,   113,    -1,    85,   112,   284,   111,   284,
     113,    -1,    85,   112,   284,   111,   284,   111,   284,   113,
      -1,    86,   112,   284,   113,    -1,    87,   112,   284,   113,
      -1,    88,   112,   284,   111,   284,   113,    -1,    89,   112,
     284,   111,   284,   113,    -1,    90,   112,   284,   111,   284,
     113,    -1,    91,   112,   284,   113,    -1,    92,   112,   181,
     113,    -1,    23,   112,   284,   111,   284,   113,    -1,    23,
     112,   284,   111,   284,   111,   284,   113,    -1,    76,   112,
     284,   113,    -1,    77,   112,   284,   113,    -1,    78,   112,
     284,   113,    -1,    79,   112,   284,   113,    -1,    80,   112,
     284,   113,    -1,    81,   112,   284,   113,    -1,    82,   112,
     284,   113,    -1,    83,   112,   284,   113,    -1,   107,   112,
     113,    -1,   108,   112,   113,    -1,   109,   112,   284,   113,
      -1,   110,   112,   284,   113,    -1,   147,    -1,   149,    -1,
     300,    -1,   301,    -1,   302,    -1,   139,    -1,   142,    -1,
     136,    -1,   140,    -1,   143,    -1,   137,    -1,   141,    -1,
     144,    -1,   138,    -1,   146,    -1,   148,    -1,   150,    -1,
     114,   115,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   487,   487,   488,   493,   502,   516,   523,   528,   533,
     538,   546,   550,   551,   552,   556,   560,   564,   568,   572,
     576,   580,   584,   588,   592,   600,   608,   613,   620,   650,
     657,   687,   698,   703,   708,   718,   722,   732,   741,   750,
     768,   772,   814,   818,   822,   826,   830,   834,   838,   845,
     859,   865,   869,   877,   898,   919,   940,   961,   982,   989,
     998,  1007,  1023,  1051,  1073,  1100,  1124,  1141,  1150,  1159,
    1175,  1196,  1200,  1208,  1216,  1236,  1268,  1288,  1332,  1349,
    1382,  1397,  1401,  1409,  1424,  1433,  1453,  1483,  1503,  1547,
    1589,  1631,  1655,  1659,  1663,  1667,  1671,  1684,  1715,  1750,
    1755,  1762,  1789,  1824,  1856,  1865,  1884,  1888,  1895,  1899,
    1907,  1919,  1946,  1992,  2023,  2054,  2085,  2091,  2100,  2105,
    2112,  2136,  2159,  2167,  2171,  2179,  2184,  2191,  2205,  2215,
    2235,  2240,  2247,  2251,  2255,  2282,  2296,  2310,  2317,  2324,
    2334,  2354,  2368,  2375,  2380,  2385,  2390,  2396,  2404,  2409,
    2416,  2426,  2446,  2453,  2460,  2468,  2485,  2493,  2505,  2519,
    2532,  2546,  2553,  2562,  2579,  2584,  2591,  2603,  2623,  2647,
    2655,  2664,  2682,  2688,  2694,  2706,  2710,  2714,  2718,  2722,
    2733,  2737,  2748,  2806,  2820,  2832,  2869,  2874,  2886,  2934,
    2947,  2975,  2976,  2981,  3012,  3020,  3024,  3028,  3032,  3036,
    3040,  3044,  3052,  3091,  3141,  3155,  3165,  3180,  3187,  3197,
    3222,  3243,  3264,  3272,  3276,  3280,  3287,  3292,  3299,  3338,
    3372,  3400,  3407,  3417,  3434,  3441,  3449,  3454,  3465,  3495,
    3510,  3554,  3602,  3700,  3705,  3712,  3717,  3724,  3802,  3807,
    3814,  3822,  3832,  3860,  3864,  3872,  3939,  4066,  4119,  4156,
    4160,  4168,  4180,  4193,  4199,  4207,  4211,  4218,  4229,  4233,
    4237,  4247,  4251,  4255,  4259,  4263,  4267,  4277,  4285,  4292,
    4300,  4308,  4317,  4324,  4331,  4338,  4345,  4352,  4359,  4364,
    4369,  4378,  4385,  4392,  4405,  4418,  4425,  4432,  4439,  4447,
    4454,  4458,  4465,  4479,  4483,  4487,  4496,  4502,  4512,  4520,
    4528,  4535,  4542,  4549,  4556,  4571,  4578,  4585,  4592,  4599,
    4606,  4613,  4620,  4627,  4634,  4641,  4648,  4655,  4662,  4669,
    4676,  4680,  4684,  4691,  4698,  4705,  4712,  4719,  4726,  4733,
    4740,  4744,  4748,  4755,  4762,  4769,  4776,  4783,  4790,  4797,
    4804,  4811,  4818,  4829,  4836,  4847,  4854,  4861,  4868,  4875,
    4882,  4889,  4896,  4907,  4924,  4942,  4960,  4985,  4991,  5011,
    5015,  5019,  5026,  5030,  5034,  5042,  5046,  5050,  5058,  5062,
    5066,  5078,  5084,  5104,  5110
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SELECT", "FROM", "WHERE", "OPTIONAL",
  "DESCRIBE", "CONSTRUCT", "ASK", "DISTINCT", "REDUCED", "LIMIT", "UNION",
  "PREFIX", "BASE", "BOUND", "GRAPH", "NAMED", "FILTER", "OFFSET", "ORDER",
  "BY", "REGEX", "ASC", "DESC", "LANGMATCHES", "\"a\"", "\"strlang\"",
  "\"strdt\"", "\"str\"", "\"iri\"", "\"uri\"", "\"bnode\"", "\"lang\"",
  "\"datatype\"", "\"isUri\"", "\"isBlank\"", "\"isLiteral\"",
  "\"isNumeric\"", "\"sameTerm\"", "GROUP", "HAVING", "COUNT", "SUM",
  "AVG", "MIN", "MAX", "GROUP_CONCAT", "SAMPLE", "SEPARATOR", "DELETE",
  "INSERT", "WITH", "CLEAR", "CREATE", "SILENT", "DATA", "DROP", "LOAD",
  "INTO", "DEFAULT", "TO", "ADD", "MOVE", "COPY", "ALL", "COALESCE", "AS",
  "IF", "NOT", "IN", "BINDINGS", "UNDEF", "SERVICE", "MINUS", "YEAR",
  "MONTH", "DAY", "HOURS", "MINUTES", "SECONDS", "TIMEZONE", "TZ",
  "STRLEN", "SUBSTR", "UCASE", "LCASE", "STRSTARTS", "STRENDS", "CONTAINS",
  "ENCODE_FOR_URI", "CONCAT", "BIND", "ABS", "ROUND", "CEIL", "FLOOR",
  "RAND", "MD5", "SHA1", "SHA224", "SHA256", "SHA384", "SHA512", "EXPLAIN",
  "LET", "CURRENT_DATETIME", "NOW", "FROM_UNIXTIME", "TO_UNIXTIME", "','",
  "'('", "')'", "'['", "']'", "'{'", "'}'", "'?'", "'$'", "HATHAT",
  "SC_OR", "SC_AND", "EQ", "NEQ", "LT", "GT", "LE", "GE", "'+'", "'-'",
  "'*'", "'/'", "\":=\"", "\"string\"", "\"language tag\"",
  "\"double literal\"", "\"double positive literal\"",
  "\"double negative literal\"", "\"integer literal\"",
  "\"integer positive literal\"", "\"integer negative literal\"",
  "\"decimal literal\"", "\"decimal positive literal\"",
  "\"decimal negative literal\"", "\"boolean literal\"", "\"URI literal\"",
  "\"URI literal (\"", "\"QName literal\"", "\"QName literal (\"",
  "\"blank node literal\"", "\"identifier\"", "';'", "'.'", "'!'",
  "$accept", "Sparql", "Query", "ExplainOpt", "ReportFormat", "Update",
  "UpdateTailOpt", "UpdateOperation", "Prologue", "BaseDeclOpt",
  "PrefixDeclListOpt", "SelectQuery", "SubSelect", "SelectClause",
  "SelectExpressionList", "SelectExpressionListTail", "SelectTerm",
  "AggregateExpression", "DistinctOpt", "ExpressionOrStar",
  "CountAggregateExpression", "SumAggregateExpression",
  "AvgAggregateExpression", "MinAggregateExpression",
  "MaxAggregateExpression", "SeparatorOpt", "ExpressionList",
  "GroupConcatAggregateExpression", "SampleAggregateExpression",
  "ConstructQuery", "DescribeQuery", "VarOrIRIrefList", "AskQuery",
  "DatasetClause", "GraphRef", "DeleteQuery", "GraphTriples",
  "GraphTemplate", "ModifyTemplate", "ModifyTemplateList", "InsertQuery",
  "UpdateQuery", "GraphRefAll", "ClearQuery", "SilentOpt", "CreateQuery",
  "DropQuery", "IriRefList", "GraphOrDefault", "OldGraphRef", "LoadQuery",
  "AddQuery", "MoveQuery", "CopyQuery", "DatasetClauseList",
  "DatasetClauseListOpt", "DefaultGraphClause", "NamedGraphClause",
  "SourceSelector", "WhereClause", "WhereClauseOpt", "SolutionModifier",
  "GroupConditionList", "AsVarOpt", "GroupCondition", "GroupClauseOpt",
  "HavingCondition", "HavingConditionList", "HavingClauseOpt",
  "LimitOffsetClausesOpt", "OrderClauseOpt", "OrderConditionList",
  "OrderCondition", "LimitClause", "OffsetClause", "BindingsClauseOpt",
  "VarList", "BindingsRowListOpt", "BindingsRowList", "BindingsRow",
  "BindingValueList", "RDFLiteral", "BindingValue", "GroupGraphPattern",
  "GroupGraphPatternSub", "TriplesBlockOpt", "GraphPatternListOpt",
  "GraphPatternList", "GraphPatternListFilter", "DotOptional",
  "TriplesBlock", "GraphPatternNotTriples", "OptionalGraphPattern",
  "GraphGraphPattern", "ServiceGraphPattern", "MinusGraphPattern",
  "GroupOrUnionGraphPattern", "GroupOrUnionGraphPatternList",
  "LetGraphPattern", "BindGraphPattern", "Filter", "Constraint",
  "ParamsOpt", "FunctionCall", "CoalesceExpression", "ArgList",
  "ArgListNoBraces", "ConstructTemplate", "ConstructTriplesOpt",
  "ConstructTriples", "TriplesSameSubject", "PropertyListNotEmpty",
  "PropertyListTailOpt", "PropertyList", "ObjectList", "ObjectTail",
  "Object", "Verb", "TriplesNode", "BlankNodePropertyList", "Collection",
  "GraphNodeListNotEmpty", "GraphNode", "VarOrTerm", "VarOrIRIref", "Var",
  "VarName", "VarOrBadVarName", "GraphTerm", "Expression",
  "ConditionalOrExpression", "ConditionalAndExpression",
  "RelationalExpression", "AdditiveExpression", "MultiplicativeExpression",
  "UnaryExpression", "PrimaryExpression", "BrackettedExpression",
  "BuiltInCall", "StringExpression", "RegexExpression",
  "DatetimeBuiltinAccessors", "DatetimeExtensions", "IRIrefBrace",
  "NumericLiteral", "NumericLiteralUnsigned", "NumericLiteralPositive",
  "NumericLiteralNegative", "IRIref", "BlankNode", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    44,    40,    41,    91,    93,   123,   125,    63,    36,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    43,
      45,    42,    47,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,    59,    46,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   155,   156,   156,   157,   158,   158,   159,   159,   159,
     159,   160,   161,   161,   161,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   163,   164,   164,   165,   165,
     166,   167,   168,   168,   168,   169,   169,   170,   170,   170,
     171,   171,   172,   172,   172,   172,   172,   172,   172,   173,
     173,   174,   174,   175,   176,   177,   178,   179,   180,   180,
     181,   181,   182,   183,   184,   185,   185,   186,   186,   186,
     187,   188,   188,   189,   190,   190,   190,   190,   191,   191,
     192,   193,   193,   194,   194,   195,   195,   195,   196,   196,
     196,   196,   197,   197,   197,   197,   197,   198,   198,   199,
     199,   200,   200,   201,   202,   202,   203,   203,   204,   204,
     204,   205,   205,   206,   207,   208,   209,   209,   210,   210,
     211,   212,   213,   214,   214,   215,   215,   216,   217,   217,
     218,   218,   219,   219,   219,   219,   220,   220,   221,   222,
     222,   223,   223,   224,   224,   224,   224,   224,   225,   225,
     226,   226,   227,   227,   227,   227,   227,   227,   228,   229,
     230,   230,   231,   231,   232,   232,   233,   233,   234,   234,
     235,   235,   236,   236,   236,   237,   237,   237,   237,   237,
     238,   238,   239,   240,   240,   241,   241,   241,   242,   243,
     243,   244,   244,   245,   245,   246,   246,   246,   246,   246,
     246,   246,   247,   248,   249,   250,   251,   251,   252,   252,
     253,   254,   255,   256,   256,   256,   257,   257,   258,   258,
     259,   260,   261,   261,   261,   262,   263,   263,   264,   264,
     265,   265,   266,   267,   267,   268,   268,   269,   270,   270,
     271,   272,   272,   273,   273,   274,   275,   276,   276,   277,
     277,   278,   278,   279,   279,   280,   280,   281,   282,   282,
     282,   283,   283,   283,   283,   283,   283,   284,   285,   285,
     286,   286,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   288,   288,   288,   288,   288,   289,   289,   289,   290,
     290,   290,   290,   291,   291,   291,   291,   291,   291,   292,
     293,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   295,   295,   296,   296,   296,   296,   296,
     296,   296,   296,   297,   297,   297,   297,   298,   298,   299,
     299,   299,   300,   300,   300,   301,   301,   301,   302,   302,
     302,   303,   303,   304,   304
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     4,     1,     0,     1,     1,     1,
       1,     3,     2,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     0,     4,     0,
       4,     3,     3,     3,     2,     1,     1,     2,     3,     1,
       1,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     5,     5,     5,     5,     5,     4,     0,
       3,     1,     6,     5,     5,     5,     5,     2,     3,     1,
       3,     2,     2,     2,     3,     5,     5,     3,     1,     5,
       5,     1,     1,     2,     1,     3,     5,     5,    11,     7,
       7,     7,     1,     1,     1,     1,     2,     3,     1,     1,
       0,     3,     3,     3,     2,     1,     1,     1,     1,     1,
       1,     3,     5,     5,     5,     5,     2,     1,     1,     0,
       1,     2,     1,     2,     1,     1,     0,     4,     2,     1,
       2,     0,     1,     1,     4,     1,     3,     0,     1,     2,
       1,     2,     0,     2,     2,     1,     1,     0,     3,     0,
       2,     1,     2,     2,     1,     1,     1,     1,     2,     2,
       5,     0,     2,     1,     1,     0,     2,     1,     3,     2,
       2,     1,     1,     2,     3,     1,     1,     1,     1,     1,
       3,     3,     2,     1,     0,     2,     1,     0,     3,     1,
       1,     1,     0,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     3,     2,     3,     1,     3,     1,
       6,     6,     2,     1,     1,     1,     1,     0,     6,     3,
       2,     3,     3,     1,     0,     3,     1,     0,     3,     1,
       2,     2,     3,     2,     0,     1,     0,     2,     2,     0,
       1,     1,     1,     1,     1,     3,     3,     2,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     2,     1,     3,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     4,
       1,     3,     3,     2,     2,     1,     3,     3,     1,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       4,     4,     6,     4,     4,     4,     4,     4,     3,     3,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       1,     1,     8,     6,     6,     6,     4,     4,     4,     4,
       1,     1,     1,     4,     6,     8,     4,     4,     6,     6,
       6,     4,     4,     6,     8,     4,     4,     4,     4,     4,
       4,     4,     4,     3,     3,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      27,     0,     0,     2,     3,     6,    29,    26,     1,     0,
       0,     0,   100,   100,   100,   100,   100,   100,   100,     5,
       0,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,     0,     0,     0,     0,   117,   126,     0,
       0,   126,     0,    99,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   119,   161,     7,   119,     8,     9,
      10,    27,    11,     0,     0,   371,   372,    71,    72,   120,
     122,   184,    77,     0,     0,     0,     0,     0,     0,   172,
     364,   367,   370,   362,   365,   368,   363,   366,   369,   264,
     373,    82,    84,     0,   262,    81,   229,   236,   244,   243,
       0,   251,   252,   263,   359,   360,   361,   261,   265,     0,
     116,   125,    74,   124,     0,     0,    85,     0,     0,     0,
      94,    93,    95,    92,    97,     0,   101,   102,   103,   105,
       0,   106,   107,     0,     0,     0,     0,     0,     0,    36,
      34,    35,    39,    40,   119,   119,    69,   253,   254,   227,
     119,   118,     0,     0,     4,     0,    12,     0,     0,   121,
       0,     0,     0,   187,   183,   194,     0,     0,    78,     0,
     266,   250,     0,   248,   249,   242,   374,     0,     0,   241,
     257,   255,   256,     0,   173,     0,    83,   227,   235,   231,
     230,   123,     0,   126,     0,     0,     0,    96,    73,     0,
     104,     0,     0,     0,    32,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   357,   358,     0,
     298,    42,    43,    44,    45,    46,    47,    48,   295,   321,
     297,   296,     0,   267,   269,   271,   280,   285,   288,   292,
     293,   294,   320,   330,   331,   332,   224,   261,     0,    37,
     126,     0,   126,    67,     0,   226,     0,    70,     0,   163,
     137,    28,   180,   137,   181,     0,     0,     0,     0,     0,
       0,     0,   207,   182,   186,   192,   189,   196,   198,   199,
     197,   195,   200,   201,   190,   184,     0,    76,     0,   246,
     247,   245,   234,   239,   240,   174,    75,   228,    87,    86,
       0,     0,     0,   110,   109,   108,   112,   113,   114,   115,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    50,    50,    50,    50,
      50,    50,    50,   224,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   290,
     291,   289,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   283,   284,     0,     0,     0,
     223,    50,    38,   137,    68,   137,   225,   137,   165,   162,
       0,    30,   142,    31,   202,     0,     0,   212,   215,   213,
     214,     0,     0,   205,     0,     0,     0,   185,   191,   184,
     193,     0,     0,   236,   232,     0,   237,   126,     0,   126,
       0,     0,     0,     0,     0,     0,     0,     0,   308,     0,
       0,     0,     0,     0,     0,     0,     0,    49,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    61,     0,     0,     0,     0,   309,
       0,     0,     0,     0,     0,     0,   353,   354,     0,     0,
     299,     0,     0,   260,     0,   268,   270,     0,   278,   272,
     273,   274,   275,   276,   277,   281,   282,   286,   287,     0,
     219,   224,    66,    65,    64,     0,     0,   164,   167,     0,
       0,   149,   203,   204,     0,     0,   209,   206,   188,     0,
      80,   233,   238,     0,    89,    91,    90,   304,     0,     0,
       0,     0,   300,   305,   306,   307,   301,   303,   326,   327,
     328,   329,     0,    52,     0,    51,     0,     0,     0,     0,
      59,     0,   221,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   333,     0,   336,   337,     0,     0,     0,   341,
       0,   342,   310,   313,   311,   312,   314,   315,   316,   317,
     318,   319,   355,   356,   258,   259,    41,   279,   222,   217,
     179,   169,   178,     0,   176,   171,   177,   175,   160,   166,
       0,   136,   129,   133,   135,   132,   140,   141,   138,     0,
     147,     0,     0,     0,    79,     0,     0,     0,     0,     0,
       0,    53,    54,    55,    56,    57,     0,     0,    63,     0,
       0,     0,     0,     0,    60,   216,     0,   168,   170,   131,
     128,   139,     0,     0,     0,   127,   145,   146,     0,     0,
     208,     0,     0,   343,   302,   323,   324,   325,     0,    62,
       0,     0,   334,   338,   339,   340,   218,     0,     0,     0,
       0,   148,   151,   154,   155,   156,   157,   158,   159,   143,
     144,   211,   210,   126,     0,     0,     0,     0,   130,   134,
     152,   153,   150,    88,   344,    58,   322,   335
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    20,    55,     4,    62,    21,     5,     6,
      32,    56,   160,    57,   140,   141,   142,   270,   498,   604,
     271,   272,   273,   274,   275,   687,   523,   276,   277,    58,
      59,   145,    60,    37,   123,    22,   167,    91,    92,    93,
      23,    24,   124,    25,    44,    26,    27,   130,   133,   356,
      28,    29,    30,    31,   151,   152,    67,    68,    69,   111,
     112,   451,   661,   728,   662,   452,   666,   667,   571,   705,
     670,   731,   732,   706,   707,   154,   308,   566,   567,   568,
     653,    94,   655,   113,   162,   163,   323,   324,   325,   469,
     164,   326,   327,   328,   329,   330,   331,   577,   332,   333,
     334,   668,   696,   278,   279,   384,   439,   150,   304,    95,
      96,   188,   474,   189,   342,   476,   343,   178,    97,    98,
      99,   172,   344,   100,   179,   280,   181,   544,   281,   440,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   103,   104,   105,   106,   297,   108
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -531
static const yytype_int16 yypact[] =
{
      45,   -97,    66,  -531,  -531,   552,  -531,  -531,  -531,    86,
      63,   -83,    24,    16,    16,    16,    16,    16,    16,  -531,
     389,   -74,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,
    -531,  -531,    74,    35,   -18,    -5,  1810,  -531,    97,     5,
    1810,    97,   133,  -531,   207,    34,   207,   -17,   -14,   -14,
     -14,   186,   270,     8,    90,    62,  -531,    90,  -531,  -531,
    -531,    64,  -531,    -1,    -4,  -531,  -531,  -531,  -531,  -531,
    -531,    96,  -531,  1853,   130,  1892,   192,     2,     2,   -43,
    -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,
    -531,  -531,  -531,   335,  -531,  -531,    19,    47,  -531,  -531,
      47,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,   -18,
    -531,  -531,  -531,  -531,  1853,   609,  -531,    51,   -11,    -7,
    -531,  -531,  -531,  -531,  -531,    46,  -531,  -531,  -531,    25,
     -15,  -531,  -531,   136,   144,   150,   224,   224,  1235,  -531,
    -531,   139,  -531,  -531,    90,   134,  -531,  -531,  -531,  1966,
      90,    90,    71,   194,  -531,    71,  -531,   476,    75,  -531,
     100,    71,   109,   316,  -531,    94,   114,   138,  -531,   115,
    -531,  -531,  1931,  -531,  -531,  -531,  -531,   176,  1966,  -531,
    -531,  -531,  -531,    -4,  -531,    71,  -531,  1966,  -531,  -531,
    -531,  -531,   197,    71,  1810,   216,  1810,  -531,  -531,    14,
    -531,   -14,   -14,   -14,  -531,  -531,   188,   225,   227,   232,
     236,   238,   244,   247,   249,   250,   251,   253,   254,   257,
     258,   263,   264,   265,   266,   267,   269,   282,   283,   288,
     294,   296,   298,   299,   300,   305,   307,   308,   311,   312,
     313,   314,   315,   322,   323,   330,   339,   343,   350,   351,
     352,   353,   356,   358,   370,   372,   374,   377,   378,   380,
     382,   383,   384,   830,   385,  1370,  1370,  -531,  -531,  1370,
    -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,
    -531,  -531,   419,   261,   379,  -531,   333,   490,   184,  -531,
    -531,  -531,  -531,  -531,  -531,  -531,  1235,   387,   190,  -531,
      71,   130,    71,  -531,   328,  -531,    71,  -531,    85,  -531,
     462,  -531,  -531,   462,  -531,   -18,   130,  1699,   130,   -18,
     393,   395,   497,   316,  -531,   369,  -531,  -531,  -531,  -531,
    -531,  -531,  -531,  -531,  -531,  1966,   408,  -531,  1966,  -531,
    -531,  -531,   373,   415,  -531,  -531,  -531,  -531,  -531,  -531,
     681,  1853,  1723,  -531,  -531,  -531,  -531,  -531,  -531,  -531,
     194,  1235,  1235,  1235,  1235,  1235,  1235,  1235,   965,  1235,
    1235,  1235,  1235,  1235,  1235,  1235,   522,   522,   522,   522,
     522,   522,   522,  1235,  -531,  1235,  1235,  1235,  1235,  1235,
    1235,  1235,  1235,  1235,  1235,  1235,  1235,  1235,  1235,  1235,
    1235,  1235,  1235,  1235,  1235,  1235,  1235,   423,  1235,  1235,
    1235,  1235,  1235,  1235,   429,   430,  1235,  1235,   454,  -531,
    -531,  -531,   -48,  1235,  1235,   519,   288,  1235,  1235,  1235,
    1235,  1235,  1235,  1235,  1235,  -531,  -531,  1235,  1235,   143,
    -531,   522,  -531,   462,  -531,   462,  -531,   462,   485,  -531,
     576,  -531,   559,  -531,  -531,   -18,  1235,  -531,  -531,  -531,
    -531,   387,   -18,  -531,  1235,   194,   -18,  -531,  -531,  1966,
    -531,  1966,   491,    47,  -531,  1966,  -531,    29,   492,    71,
     499,   502,   503,   507,   511,   512,   523,   525,  -531,   527,
     528,   529,   531,   532,   533,   535,   513,  -531,  1100,  1235,
    1235,  1235,  1235,  1235,  1235,   152,   521,   536,   537,   539,
     540,   541,   542,   543,   551,   553,   554,   555,   556,   560,
     561,   562,   563,   161,  -531,   564,   565,   567,   575,  -531,
     577,   578,   579,   580,   582,   583,  -531,  -531,   587,   588,
    -531,     2,     2,  -531,   590,   379,  -531,   288,  -531,  -531,
    -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  1235,
    -531,  1235,  -531,  -531,  -531,   375,   550,   485,  -531,  1602,
    1699,   653,  -531,  -531,   607,   572,  -531,   676,  -531,   589,
    -531,  -531,  -531,   591,  -531,  -531,  -531,  -531,  1235,  1235,
    1235,  1235,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,
    -531,  -531,  1235,  -531,   596,  -531,   597,   598,   599,   600,
     -56,   601,  -531,  1235,  -531,  -531,  -531,  -531,  -531,  -531,
    -531,  -531,  -531,  1235,  -531,  -531,  1235,  1235,  1235,  -531,
    1235,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,
    -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,   -52,
    -531,  -531,  -531,  1412,  -531,  -531,  -531,  -531,  -531,  -531,
    1235,  1602,  -531,  -531,  -531,  -531,  -531,  1699,  -531,   693,
     102,   194,  1235,   -18,  -531,  1810,   166,   603,   604,   605,
     606,  -531,  -531,  -531,  -531,  -531,   670,   611,  -531,   614,
     170,   616,   617,   618,  -531,  -531,   619,  -531,  -531,   654,
    -531,  -531,  1505,   595,   602,  -531,   716,   725,   625,   626,
    -531,  1775,  1235,  -531,  -531,  -531,  -531,  -531,   633,  -531,
    1235,  1235,  -531,  -531,  -531,  -531,  -531,   194,   627,   646,
     646,  1505,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,
    -531,  -531,  -531,    71,   648,   628,   650,   652,  -531,  -531,
    -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -531,  -531,  -531,  -531,  -531,   705,  -531,  -531,   706,  -531,
    -531,  -531,  -531,   697,   193,  -531,  -130,  -531,   -54,  -531,
    -531,  -531,  -531,  -531,  -531,  -531,   272,  -531,  -531,  -531,
    -531,  -531,  -531,    48,   -24,  -531,  -108,  -531,   -88,   -38,
    -531,  -531,   723,  -531,   645,  -531,  -531,  -531,   -12,  -531,
    -531,  -531,  -531,  -531,   336,    78,  -531,  -531,   712,  -133,
     -41,  -284,  -531,  -531,   116,  -531,   103,  -531,  -531,  -531,
    -531,  -531,    50,    72,    76,  -531,  -531,  -531,  -531,   211,
    -531,  -530,   127,   -22,  -531,  -312,  -531,   460,  -531,  -531,
     -57,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,
    -531,   467,  -531,  -303,  -531,  -393,  -373,  -531,   610,  -131,
     -64,    49,  -531,   317,   319,  -531,  -531,  -531,   -62,  -531,
    -531,  -531,   -45,   -60,   -26,    33,   -75,  -531,    22,   183,
    -531,   363,   364,   132,   -84,  -531,    30,  -300,  -281,  -531,
    -531,  -531,  -531,  -531,  -525,  -531,   500,   504,   -32,  -531
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -112
static const yytype_int16 yytable[] =
{
     116,    70,   115,   182,   107,   186,   192,   165,   107,   165,
     505,   299,    72,   171,   458,   174,   168,   459,   305,   307,
     148,   127,   310,   470,   -98,  -111,   146,   186,   313,   453,
     173,   125,    70,   548,   109,   654,   460,   134,   135,   107,
     656,   107,   148,   107,   148,   199,   195,   131,   169,     7,
     165,   125,   346,    64,   197,   630,   305,   168,   102,   559,
       1,   107,   102,    42,   -13,   148,     8,    33,   148,   101,
     541,   542,    43,   101,   175,   353,   109,   183,    61,     1,
      43,   583,   107,   107,   143,   147,   110,   191,    63,   110,
      33,    34,   184,   102,    33,   102,   686,   102,    71,    51,
     695,    33,   109,   180,   101,   196,   101,   147,   101,   147,
     171,    73,   174,   148,   703,   102,   171,   107,   174,   303,
      39,   114,   704,   654,   149,   177,   101,   340,   656,   129,
     147,   200,   132,   147,   153,   155,   102,   102,    33,   198,
     107,   322,    65,    35,    66,    71,   107,   101,   101,   190,
     158,   345,   349,   180,   647,   107,   350,   578,   352,   562,
     354,   563,   107,   564,   107,    77,    78,   194,   442,   143,
     143,   102,   187,   447,   143,   355,   -98,  -111,   147,    40,
     126,    65,   101,    66,   117,   118,   309,    71,   649,   357,
     358,   359,   198,    65,   102,    66,   136,   137,   201,   110,
     102,   448,    36,    77,    78,   101,   202,   472,    75,   102,
      76,   101,   203,    71,    77,    78,   102,   312,   102,   175,
     101,   311,   300,   302,   119,   120,   314,   101,   306,   101,
      79,   338,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    65,   478,    66,   301,    90,   335,    77,    78,
     298,   138,    77,    78,   559,   337,   560,    77,    78,   443,
     336,   445,   186,   559,   186,   612,   663,   458,   121,   148,
     459,   165,   630,   122,   631,   444,    65,   712,    66,   713,
      65,   721,    66,   722,   148,   461,   148,   165,   665,   460,
     455,   341,   462,   454,   168,   419,   420,   463,   138,   421,
     360,   322,   138,   107,    77,    78,   107,   176,    77,    78,
      77,    78,    77,    78,   348,   437,   438,   139,   107,   107,
     107,   282,   315,   499,   500,   501,   502,   503,   504,   204,
     205,   143,   351,   316,   147,   317,   138,   361,    65,   362,
      66,   449,    77,    78,   363,    38,    41,   543,   364,   147,
     365,   147,    74,   557,   558,   139,   366,   102,   663,   367,
     102,   368,   369,   370,   458,   371,   372,   459,   101,   373,
     374,   101,   102,   102,   102,   375,   376,   377,   378,   379,
     665,   380,   423,   101,   101,   101,   460,   561,    77,    78,
     318,   319,    51,   480,   381,   382,    52,    53,    54,   733,
     383,   144,   735,   425,   426,   165,   385,   165,   386,   320,
     387,   388,   389,   171,   579,   174,    65,   390,    66,   391,
     392,   736,   321,   393,   394,   395,   396,   397,   733,   750,
     751,   735,    71,   572,   398,   399,   584,   107,   586,   107,
     573,   148,   400,   107,   576,   446,   418,    75,   650,    76,
     736,   401,   185,    77,    78,   402,   427,   428,   429,   430,
     431,   432,   403,   404,   405,   406,   644,   645,   407,    79,
     408,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    65,   409,    66,   410,    90,   411,   422,   651,   412,
     413,   102,   414,   102,   415,   416,   417,   102,   575,   441,
     176,   424,   101,   450,   101,   464,   147,   465,   101,    79,
     466,    80,    81,    82,    83,    84,    85,    86,    87,    88,
     652,    65,   468,    66,   471,   473,   475,     9,    10,    11,
      12,    13,   497,   657,    14,    15,   529,   461,   461,    16,
      17,    18,   536,   537,   481,   482,   483,   484,   485,   486,
     487,   489,   490,   491,   492,   493,   494,   495,   496,   549,
     550,   551,   552,   553,   554,   555,   556,   540,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   524,   525,   526,   527,   528,
     547,   530,   531,   532,   533,   534,   535,   565,   569,   538,
     539,   570,   664,     9,    10,    11,    12,    13,   580,   585,
      14,    15,   587,   588,   589,    16,    17,    18,   590,   433,
     434,   657,   591,   186,   602,   592,    74,    81,    82,   461,
      84,    85,   613,    87,    88,   461,   593,   711,   594,   418,
     595,   596,   597,   107,   598,   599,   600,   574,   601,   614,
     615,   710,   616,   617,   618,   619,   620,    19,    45,    46,
      47,    48,    49,    50,   621,   623,   622,   658,   624,   625,
     461,   626,   627,   628,   669,   671,   629,   632,   633,   107,
     634,   605,   606,   607,   608,   609,   524,   611,   635,   673,
     636,   637,   638,   639,   664,   640,   641,   102,    74,   461,
     642,   643,   753,   646,   708,   672,   674,   675,   101,   681,
     682,   683,   684,   685,   688,   702,   714,   715,   716,   717,
     718,    75,   727,    76,   719,   720,   193,    77,    78,   723,
     724,   725,   726,   102,   737,   734,   704,   703,   741,   742,
     749,   738,   648,    79,   101,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    65,   745,    66,   456,    90,
     748,   754,   755,   756,   734,   757,   156,   157,   161,   128,
     701,   676,   677,   678,   679,   610,   159,   700,   659,   740,
     698,   752,   739,   467,   457,   680,   545,   435,   546,     0,
     581,   436,     0,    75,   582,    76,   689,   347,   477,    77,
      78,     0,     0,     0,     0,     0,   690,     0,     0,   691,
     692,   693,     0,   694,     0,    79,     0,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    65,     0,    66,
       0,    90,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   699,     0,     0,   206,     0,     0,     0,
       0,     0,     0,   207,     0,   709,   208,     0,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,     0,     0,   222,   223,   224,   225,   226,   227,   228,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   744,     0,   229,     0,   230,
       0,     0,     0,   746,   747,     0,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,     0,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,     0,     0,   259,   260,   261,
     262,     0,   263,   170,   264,     0,     0,     0,    77,    78,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   265,
     266,     0,     0,     0,    79,     0,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    65,   267,    66,   268,
      90,   206,     0,     0,   269,     0,     0,     0,   207,     0,
       0,   208,     0,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,   228,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   229,     0,   230,     0,     0,     0,     0,     0,
       0,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
       0,     0,   259,   260,   261,   262,     0,   263,   488,   264,
       0,     0,     0,    77,    78,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   265,   266,     0,     0,     0,    79,
       0,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    65,   267,    66,   268,    90,   206,     0,     0,   269,
       0,     0,     0,   207,     0,     0,   208,     0,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,     0,     0,   222,   223,   224,   225,   226,   227,   228,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   229,     0,   230,
       0,     0,     0,     0,     0,     0,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,     0,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,     0,     0,   259,   260,   261,
     262,     0,   263,     0,   264,     0,     0,     0,    77,    78,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   265,
     266,   603,     0,     0,    79,     0,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    65,   267,    66,   268,
      90,   206,     0,     0,   269,     0,     0,     0,   207,     0,
       0,   208,     0,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,   228,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   229,     0,   230,     0,     0,     0,     0,     0,
       0,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
       0,     0,   259,   260,   261,   262,     0,   263,     0,   264,
       0,     0,     0,    77,    78,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   265,   266,     0,     0,     0,    79,
       0,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    65,   267,    66,   268,    90,   206,     0,     0,   269,
       0,     0,     0,   207,     0,     0,   208,     0,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,     0,     0,   222,   223,   224,   225,   226,   227,   228,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   229,     0,   230,
       0,     0,     0,     0,     0,     0,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,     0,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,     0,     0,   259,   260,   261,
     262,     0,   263,     0,   264,   650,     0,     0,    77,    78,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    79,     0,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    65,   267,    66,   268,
      90,   206,     0,     0,     0,   697,     0,     0,   207,   729,
     730,   208,     0,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,    79,     0,    80,    81,
      82,    83,    84,    85,    86,    87,    88,   652,    65,     0,
      66,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   229,     0,   230,     0,     0,     0,     0,     0,
       0,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
       0,     0,   259,   260,   261,   262,     0,   456,   206,     0,
       0,     0,     0,    77,    78,   207,     0,     0,   208,     0,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,     0,     0,     0,     0,     0,     0,     0,
       0,    65,   267,    66,   268,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   229,
       0,   230,     0,     0,     0,     0,     0,     0,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,     0,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,     0,     0,   259,
     260,   261,   262,     0,   660,   206,     0,     0,     0,     0,
      77,    78,   207,     0,     0,   208,     0,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
      74,     0,     0,     0,     0,     0,     0,     0,    65,   267,
      66,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   229,     0,   230,     0,
       0,     0,     0,     0,     0,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,    74,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,     0,     0,   259,   260,   261,   262,
       0,   456,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    74,     0,     0,
       0,     0,     0,     0,     0,    75,     0,    76,     0,     0,
     479,    77,    78,     0,     0,    65,   267,    66,   268,     0,
       0,     0,     0,     0,     0,     0,     0,    79,     0,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    65,
     166,    66,     0,    90,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    75,     0,    76,
       0,     0,   743,    77,    78,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
       0,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    65,    75,    66,    76,    90,     0,     0,    77,    78,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    79,     0,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    65,     0,    66,     0,
      90,     0,     0,     0,     0,    75,     0,    76,     0,     0,
       0,    77,    78,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    79,     0,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    65,
       0,    66,     0,    90,    75,   170,    76,     0,     0,     0,
      77,    78,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    79,     0,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    65,     0,
      66,     0,    90,    75,   339,    76,     0,     0,     0,    77,
      78,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    79,     0,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    65,    75,    66,
      76,    90,     0,     0,    77,    78,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      79,     0,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    65,     0,    66,     0,    90
};

static const yytype_int16 yycheck[] =
{
      41,    33,    40,    78,    36,    93,   114,    71,    40,    73,
     383,   141,    34,    75,   317,    75,    73,   317,   149,   152,
      52,    45,   155,   335,     0,     0,    52,   115,   161,   313,
      75,    17,    64,   426,     5,   565,   317,    49,    50,    71,
     565,    73,    74,    75,    76,    60,    57,    61,    74,   146,
     114,    17,   185,    18,    61,   111,   187,   114,    36,   111,
      15,    93,    40,   146,     0,    97,     0,     4,   100,    36,
     118,   119,    56,    40,    27,    61,     5,   120,   152,    15,
      56,    52,   114,   115,    51,    52,    38,   109,    14,    41,
       4,     5,   135,    71,     4,    73,   152,    75,   116,     3,
     152,     4,     5,   151,    71,   116,    73,    74,    75,    76,
     172,   116,   172,   145,    12,    93,   178,   149,   178,   145,
      57,   116,    20,   653,   116,    76,    93,   172,   653,   146,
      97,   146,   146,   100,    72,    57,   114,   115,     4,   146,
     172,   163,   146,    57,   148,   116,   178,   114,   115,   100,
     151,   183,   193,   151,   547,   187,   194,   469,   196,   443,
     146,   445,   194,   447,   196,   118,   119,   116,   298,   136,
     137,   149,   153,   306,   141,   199,   152,   152,   145,   116,
     146,   146,   149,   148,    51,    52,   153,   116,   561,   201,
     202,   203,   146,   146,   172,   148,    10,    11,    62,   151,
     178,   116,   116,   118,   119,   172,    62,   338,   112,   187,
     114,   178,    62,   116,   118,   119,   194,   117,   196,    27,
     187,   146,   144,   145,    17,    18,   117,   194,   150,   196,
     134,   116,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   351,   148,   111,   150,   153,   118,   119,
     111,   112,   118,   119,   111,   117,   113,   118,   119,   300,
     146,   302,   350,   111,   352,   113,   569,   570,    61,   301,
     570,   335,   111,    66,   113,   301,   146,   111,   148,   113,
     146,   111,   148,   113,   316,   317,   318,   351,   569,   570,
     316,   115,   318,   315,   351,   265,   266,   319,   112,   269,
     112,   323,   112,   335,   118,   119,   338,   115,   118,   119,
     118,   119,   118,   119,   117,   131,   132,   131,   350,   351,
     352,   138,     6,   377,   378,   379,   380,   381,   382,   136,
     137,   298,   116,    17,   301,    19,   112,   112,   146,   112,
     148,   308,   118,   119,   112,     9,    10,   422,   112,   316,
     112,   318,    17,   437,   438,   131,   112,   335,   661,   112,
     338,   112,   112,   112,   667,   112,   112,   667,   335,   112,
     112,   338,   350,   351,   352,   112,   112,   112,   112,   112,
     661,   112,   121,   350,   351,   352,   667,   441,   118,   119,
      74,    75,     3,   360,   112,   112,     7,     8,     9,   702,
     112,   131,   702,    70,    71,   469,   112,   471,   112,    93,
     112,   112,   112,   475,   471,   475,   146,   112,   148,   112,
     112,   702,   106,   112,   112,   112,   112,   112,   731,   729,
     730,   731,   116,   455,   112,   112,   477,   469,   479,   471,
     462,   473,   112,   475,   466,   117,   263,   112,    73,   114,
     731,   112,   117,   118,   119,   112,   123,   124,   125,   126,
     127,   128,   112,   112,   112,   112,   541,   542,   112,   134,
     112,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   112,   148,   112,   150,   112,    68,   113,   112,
     112,   469,   112,   471,   112,   112,   112,   475,   465,   112,
     115,   122,   469,    41,   471,   112,   473,   112,   475,   134,
      13,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   153,   148,   116,   152,   111,    51,    52,    53,
      54,    55,    10,   565,    58,    59,   113,   569,   570,    63,
      64,    65,   113,   113,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   427,
     428,   429,   430,   431,   432,   433,   434,   113,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
      71,   408,   409,   410,   411,   412,   413,   112,    22,   416,
     417,    42,   569,    51,    52,    53,    54,    55,   117,   117,
      58,    59,   113,   111,   111,    63,    64,    65,   111,   129,
     130,   653,   111,   711,   111,   113,    17,   137,   138,   661,
     140,   141,   111,   143,   144,   667,   113,   675,   113,   456,
     113,   113,   113,   675,   113,   113,   113,   464,   113,   113,
     113,   673,   113,   113,   113,   113,   113,   105,    13,    14,
      15,    16,    17,    18,   113,   111,   113,   117,   113,   113,
     702,   111,   111,   111,    21,    68,   113,   113,   113,   711,
     113,   498,   499,   500,   501,   502,   503,   504,   113,    13,
     113,   113,   113,   113,   661,   113,   113,   675,    17,   731,
     113,   113,   743,   113,   671,   133,   117,   116,   675,   113,
     113,   113,   113,   113,   113,    22,   113,   113,   113,   113,
      50,   112,    68,   114,   113,   111,   117,   118,   119,   113,
     113,   113,   113,   711,   139,   702,    20,    12,   113,   113,
     113,   139,   559,   134,   711,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   123,   148,   112,   150,
     727,   113,   134,   113,   731,   113,    61,    61,    71,    46,
     667,   588,   589,   590,   591,   503,    64,   661,   567,   707,
     653,   731,   706,   323,   317,   602,   423,   287,   424,    -1,
     473,   287,    -1,   112,   475,   114,   613,   187,   117,   118,
     119,    -1,    -1,    -1,    -1,    -1,   623,    -1,    -1,   626,
     627,   628,    -1,   630,    -1,   134,    -1,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   660,    -1,    -1,    16,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    -1,   672,    26,    -1,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   712,    -1,    67,    -1,    69,
      -1,    -1,    -1,   720,   721,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,    -1,    -1,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,    -1,   118,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,
     130,    -1,    -1,    -1,   134,    -1,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,    16,    -1,    -1,   154,    -1,    -1,    -1,    23,    -1,
      -1,    26,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,    -1,   118,   119,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   129,   130,    -1,    -1,    -1,   134,
      -1,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,    16,    -1,    -1,   154,
      -1,    -1,    -1,    23,    -1,    -1,    26,    -1,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,    -1,    -1,   107,   108,   109,
     110,    -1,   112,    -1,   114,    -1,    -1,    -1,   118,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,
     130,   131,    -1,    -1,   134,    -1,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,    16,    -1,    -1,   154,    -1,    -1,    -1,    23,    -1,
      -1,    26,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,    -1,   112,    -1,   114,
      -1,    -1,    -1,   118,   119,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   129,   130,    -1,    -1,    -1,   134,
      -1,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,    16,    -1,    -1,   154,
      -1,    -1,    -1,    23,    -1,    -1,    26,    -1,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,    -1,    -1,   107,   108,   109,
     110,    -1,   112,    -1,   114,    73,    -1,    -1,   118,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,    16,    -1,    -1,    -1,   113,    -1,    -1,    23,    24,
      25,    26,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,   134,    -1,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,    -1,   112,    16,    -1,
      -1,    -1,    -1,   118,   119,    23,    -1,    -1,    26,    -1,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,   147,   148,   149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    69,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,    -1,    -1,   107,
     108,   109,   110,    -1,   112,    16,    -1,    -1,    -1,    -1,
     118,   119,    23,    -1,    -1,    26,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,   147,
     148,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    69,    -1,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    17,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
      -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   112,    -1,   114,    -1,    -1,
     117,   118,   119,    -1,    -1,   146,   147,   148,   149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
      17,   148,    -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,   114,
      -1,    -1,   117,   118,   119,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,
      -1,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   112,   148,   114,   150,    -1,    -1,   118,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,    -1,    -1,    -1,    -1,   112,    -1,   114,    -1,    -1,
      -1,   118,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
      -1,   148,    -1,   150,   112,   113,   114,    -1,    -1,    -1,
     118,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   112,   113,   114,    -1,    -1,    -1,   118,
     119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   134,    -1,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   112,   148,
     114,   150,    -1,    -1,   118,   119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    15,   156,   157,   160,   163,   164,   146,     0,    51,
      52,    53,    54,    55,    58,    59,    63,    64,    65,   105,
     158,   162,   190,   195,   196,   198,   200,   201,   205,   206,
     207,   208,   165,     4,     5,    57,   116,   188,   209,    57,
     116,   209,   146,    56,   199,   199,   199,   199,   199,   199,
     199,     3,     7,     8,     9,   159,   166,   168,   184,   185,
     187,   152,   161,    14,    18,   146,   148,   211,   212,   213,
     303,   116,   238,   116,    17,   112,   114,   118,   119,   134,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     150,   192,   193,   194,   236,   264,   265,   273,   274,   275,
     278,   280,   283,   299,   300,   301,   302,   303,   304,     5,
     188,   214,   215,   238,   116,   194,   215,    51,    52,    17,
      18,    61,    66,   189,   197,    17,   146,   189,   197,   146,
     202,    61,   146,   203,   203,   203,    10,    11,   112,   131,
     169,   170,   171,   280,   131,   186,   279,   280,   303,   116,
     262,   209,   210,    72,   230,   210,   160,   163,   151,   213,
     167,   168,   239,   240,   245,   265,    17,   191,   245,   279,
     113,   273,   276,   277,   278,    27,   115,   266,   272,   279,
     151,   281,   281,   120,   135,   117,   193,   153,   266,   268,
     266,   238,   191,   117,   116,    57,   116,    61,   146,    60,
     146,    62,    62,    62,   169,   169,    16,    23,    26,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    43,    44,    45,    46,    47,    48,    49,    67,
      69,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   107,
     108,   109,   110,   112,   114,   129,   130,   147,   149,   154,
     172,   175,   176,   177,   178,   179,   182,   183,   258,   259,
     280,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   303,   111,   171,
     210,   111,   210,   279,   263,   264,   210,   214,   231,   280,
     214,   146,   117,   214,   117,     6,    17,    19,    74,    75,
      93,   106,   238,   241,   242,   243,   246,   247,   248,   249,
     250,   251,   253,   254,   255,   153,   146,   117,   116,   113,
     277,   115,   269,   271,   277,   303,   214,   263,   117,   215,
     194,   116,   194,    61,   146,   189,   204,   203,   203,   203,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   260,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   284,   291,
     291,   291,    68,   121,   122,    70,    71,   123,   124,   125,
     126,   127,   128,   129,   130,   301,   302,   131,   132,   261,
     284,   112,   171,   215,   279,   215,   117,   214,   116,   280,
      41,   216,   220,   216,   238,   279,   112,   256,   258,   292,
     293,   303,   279,   238,   112,   112,    13,   242,   153,   244,
     240,   116,   264,   152,   267,   111,   270,   117,   191,   117,
     280,   284,   284,   284,   284,   284,   284,   284,   113,   284,
     284,   284,   284,   284,   284,   284,   284,    10,   173,   173,
     173,   173,   173,   173,   173,   261,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   181,   284,   284,   284,   284,   284,   113,
     284,   284,   284,   284,   284,   284,   113,   113,   284,   284,
     113,   118,   119,   281,   282,   286,   287,    71,   260,   288,
     288,   288,   288,   288,   288,   288,   288,   289,   289,   111,
     113,   173,   216,   216,   216,   112,   232,   233,   234,    22,
      42,   223,   238,   238,   284,   280,   238,   252,   240,   245,
     117,   268,   269,    52,   215,   117,   215,   113,   111,   111,
     111,   111,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   111,   131,   174,   284,   284,   284,   284,   284,
     181,   284,   113,   111,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   111,   113,   113,   111,   111,   111,   113,
     111,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   281,   281,   113,   260,   284,   261,
      73,   113,   145,   235,   236,   237,   299,   303,   117,   234,
     112,   217,   219,   258,   280,   293,   221,   222,   256,    21,
     225,    68,   133,    13,   117,   116,   284,   284,   284,   284,
     284,   113,   113,   113,   113,   113,   152,   180,   113,   284,
     284,   284,   284,   284,   284,   152,   257,   113,   237,   284,
     219,   221,    22,    12,    20,   224,   228,   229,   280,   284,
     238,   194,   111,   113,   113,   113,   113,   113,    50,   113,
     111,   111,   113,   113,   113,   113,   113,    68,   218,    24,
      25,   226,   227,   258,   280,   292,   293,   139,   139,   229,
     228,   113,   113,   117,   284,   123,   284,   284,   280,   113,
     292,   292,   227,   215,   113,   134,   113,   113
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 134: /* "\"string\"" */

/* Line 1000 of yacc.c  */
#line 362 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2455 "sparql_parser.c"
	break;
      case 136: /* "\"double literal\"" */

/* Line 1000 of yacc.c  */
#line 341 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2467 "sparql_parser.c"
	break;
      case 137: /* "\"double positive literal\"" */

/* Line 1000 of yacc.c  */
#line 341 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2479 "sparql_parser.c"
	break;
      case 138: /* "\"double negative literal\"" */

/* Line 1000 of yacc.c  */
#line 341 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2491 "sparql_parser.c"
	break;
      case 139: /* "\"integer literal\"" */

/* Line 1000 of yacc.c  */
#line 341 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2503 "sparql_parser.c"
	break;
      case 140: /* "\"integer positive literal\"" */

/* Line 1000 of yacc.c  */
#line 341 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2515 "sparql_parser.c"
	break;
      case 141: /* "\"integer negative literal\"" */

/* Line 1000 of yacc.c  */
#line 341 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2527 "sparql_parser.c"
	break;
      case 142: /* "\"decimal literal\"" */

/* Line 1000 of yacc.c  */
#line 341 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2539 "sparql_parser.c"
	break;
      case 143: /* "\"decimal positive literal\"" */

/* Line 1000 of yacc.c  */
#line 341 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2551 "sparql_parser.c"
	break;
      case 144: /* "\"decimal negative literal\"" */

/* Line 1000 of yacc.c  */
#line 341 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2563 "sparql_parser.c"
	break;
      case 145: /* "\"boolean literal\"" */

/* Line 1000 of yacc.c  */
#line 341 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2575 "sparql_parser.c"
	break;
      case 146: /* "\"URI literal\"" */

/* Line 1000 of yacc.c  */
#line 351 "./sparql_parser.y"
	{
  if((yyvaluep->uri))
    raptor_free_uri((yyvaluep->uri));
};

/* Line 1000 of yacc.c  */
#line 2587 "sparql_parser.c"
	break;
      case 147: /* "\"URI literal (\"" */

/* Line 1000 of yacc.c  */
#line 351 "./sparql_parser.y"
	{
  if((yyvaluep->uri))
    raptor_free_uri((yyvaluep->uri));
};

/* Line 1000 of yacc.c  */
#line 2599 "sparql_parser.c"
	break;
      case 148: /* "\"QName literal\"" */

/* Line 1000 of yacc.c  */
#line 362 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2611 "sparql_parser.c"
	break;
      case 149: /* "\"QName literal (\"" */

/* Line 1000 of yacc.c  */
#line 362 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2623 "sparql_parser.c"
	break;
      case 150: /* "\"blank node literal\"" */

/* Line 1000 of yacc.c  */
#line 362 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2635 "sparql_parser.c"
	break;
      case 151: /* "\"identifier\"" */

/* Line 1000 of yacc.c  */
#line 362 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2647 "sparql_parser.c"
	break;
      case 166: /* "SelectQuery" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2659 "sparql_parser.c"
	break;
      case 167: /* "SubSelect" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2671 "sparql_parser.c"
	break;
      case 168: /* "SelectClause" */

/* Line 1000 of yacc.c  */
#line 465 "./sparql_parser.y"
	{
  if((yyvaluep->projection))
    rasqal_free_projection((yyvaluep->projection));
};

/* Line 1000 of yacc.c  */
#line 2683 "sparql_parser.c"
	break;
      case 169: /* "SelectExpressionList" */

/* Line 1000 of yacc.c  */
#line 465 "./sparql_parser.y"
	{
  if((yyvaluep->projection))
    rasqal_free_projection((yyvaluep->projection));
};

/* Line 1000 of yacc.c  */
#line 2695 "sparql_parser.c"
	break;
      case 170: /* "SelectExpressionListTail" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2707 "sparql_parser.c"
	break;
      case 171: /* "SelectTerm" */

/* Line 1000 of yacc.c  */
#line 441 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 2719 "sparql_parser.c"
	break;
      case 172: /* "AggregateExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2731 "sparql_parser.c"
	break;
      case 174: /* "ExpressionOrStar" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2743 "sparql_parser.c"
	break;
      case 175: /* "CountAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2755 "sparql_parser.c"
	break;
      case 176: /* "SumAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2767 "sparql_parser.c"
	break;
      case 177: /* "AvgAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2779 "sparql_parser.c"
	break;
      case 178: /* "MinAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2791 "sparql_parser.c"
	break;
      case 179: /* "MaxAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2803 "sparql_parser.c"
	break;
      case 180: /* "SeparatorOpt" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2815 "sparql_parser.c"
	break;
      case 182: /* "GroupConcatAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2827 "sparql_parser.c"
	break;
      case 183: /* "SampleAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2839 "sparql_parser.c"
	break;
      case 184: /* "ConstructQuery" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2851 "sparql_parser.c"
	break;
      case 185: /* "DescribeQuery" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2863 "sparql_parser.c"
	break;
      case 186: /* "VarOrIRIrefList" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2875 "sparql_parser.c"
	break;
      case 188: /* "DatasetClause" */

/* Line 1000 of yacc.c  */
#line 447 "./sparql_parser.y"
	{
  if((yyvaluep->data_graph))
    rasqal_free_data_graph((yyvaluep->data_graph));
};

/* Line 1000 of yacc.c  */
#line 2887 "sparql_parser.c"
	break;
      case 191: /* "GraphTriples" */

/* Line 1000 of yacc.c  */
#line 385 "./sparql_parser.y"
	{
  if((yyvaluep->update))
    rasqal_free_update_operation((yyvaluep->update));
};

/* Line 1000 of yacc.c  */
#line 2899 "sparql_parser.c"
	break;
      case 192: /* "GraphTemplate" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2911 "sparql_parser.c"
	break;
      case 193: /* "ModifyTemplate" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2923 "sparql_parser.c"
	break;
      case 194: /* "ModifyTemplateList" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2935 "sparql_parser.c"
	break;
      case 197: /* "GraphRefAll" */

/* Line 1000 of yacc.c  */
#line 357 "./sparql_parser.y"
	{
  if((yyvaluep->uri_applies)->uri)
    raptor_free_uri((yyvaluep->uri_applies)->uri);
};

/* Line 1000 of yacc.c  */
#line 2947 "sparql_parser.c"
	break;
      case 202: /* "IriRefList" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2959 "sparql_parser.c"
	break;
      case 209: /* "DatasetClauseList" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2971 "sparql_parser.c"
	break;
      case 210: /* "DatasetClauseListOpt" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2983 "sparql_parser.c"
	break;
      case 211: /* "DefaultGraphClause" */

/* Line 1000 of yacc.c  */
#line 447 "./sparql_parser.y"
	{
  if((yyvaluep->data_graph))
    rasqal_free_data_graph((yyvaluep->data_graph));
};

/* Line 1000 of yacc.c  */
#line 2995 "sparql_parser.c"
	break;
      case 212: /* "NamedGraphClause" */

/* Line 1000 of yacc.c  */
#line 447 "./sparql_parser.y"
	{
  if((yyvaluep->data_graph))
    rasqal_free_data_graph((yyvaluep->data_graph));
};

/* Line 1000 of yacc.c  */
#line 3007 "sparql_parser.c"
	break;
      case 213: /* "SourceSelector" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3019 "sparql_parser.c"
	break;
      case 216: /* "SolutionModifier" */

/* Line 1000 of yacc.c  */
#line 459 "./sparql_parser.y"
	{
  if((yyvaluep->modifier))
    rasqal_free_solution_modifier((yyvaluep->modifier));
};

/* Line 1000 of yacc.c  */
#line 3031 "sparql_parser.c"
	break;
      case 217: /* "GroupConditionList" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3043 "sparql_parser.c"
	break;
      case 218: /* "AsVarOpt" */

/* Line 1000 of yacc.c  */
#line 441 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 3055 "sparql_parser.c"
	break;
      case 219: /* "GroupCondition" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3067 "sparql_parser.c"
	break;
      case 220: /* "GroupClauseOpt" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3079 "sparql_parser.c"
	break;
      case 221: /* "HavingCondition" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3091 "sparql_parser.c"
	break;
      case 222: /* "HavingConditionList" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3103 "sparql_parser.c"
	break;
      case 223: /* "HavingClauseOpt" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3115 "sparql_parser.c"
	break;
      case 225: /* "OrderClauseOpt" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3127 "sparql_parser.c"
	break;
      case 226: /* "OrderConditionList" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3139 "sparql_parser.c"
	break;
      case 227: /* "OrderCondition" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3151 "sparql_parser.c"
	break;
      case 230: /* "BindingsClauseOpt" */

/* Line 1000 of yacc.c  */
#line 472 "./sparql_parser.y"
	{
  if((yyvaluep->bindings))
    rasqal_free_bindings((yyvaluep->bindings));
};

/* Line 1000 of yacc.c  */
#line 3163 "sparql_parser.c"
	break;
      case 231: /* "VarList" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3175 "sparql_parser.c"
	break;
      case 232: /* "BindingsRowListOpt" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3187 "sparql_parser.c"
	break;
      case 233: /* "BindingsRowList" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3199 "sparql_parser.c"
	break;
      case 234: /* "BindingsRow" */

/* Line 1000 of yacc.c  */
#line 453 "./sparql_parser.y"
	{
  if((yyvaluep->row))
    rasqal_free_row((yyvaluep->row));
};

/* Line 1000 of yacc.c  */
#line 3211 "sparql_parser.c"
	break;
      case 235: /* "BindingValueList" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3223 "sparql_parser.c"
	break;
      case 236: /* "RDFLiteral" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3235 "sparql_parser.c"
	break;
      case 237: /* "BindingValue" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3247 "sparql_parser.c"
	break;
      case 238: /* "GroupGraphPattern" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3259 "sparql_parser.c"
	break;
      case 239: /* "GroupGraphPatternSub" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3271 "sparql_parser.c"
	break;
      case 240: /* "TriplesBlockOpt" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3283 "sparql_parser.c"
	break;
      case 241: /* "GraphPatternListOpt" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3295 "sparql_parser.c"
	break;
      case 242: /* "GraphPatternList" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3307 "sparql_parser.c"
	break;
      case 243: /* "GraphPatternListFilter" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3319 "sparql_parser.c"
	break;
      case 245: /* "TriplesBlock" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3331 "sparql_parser.c"
	break;
      case 246: /* "GraphPatternNotTriples" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3343 "sparql_parser.c"
	break;
      case 247: /* "OptionalGraphPattern" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3355 "sparql_parser.c"
	break;
      case 248: /* "GraphGraphPattern" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3367 "sparql_parser.c"
	break;
      case 249: /* "ServiceGraphPattern" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3379 "sparql_parser.c"
	break;
      case 250: /* "MinusGraphPattern" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3391 "sparql_parser.c"
	break;
      case 251: /* "GroupOrUnionGraphPattern" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3403 "sparql_parser.c"
	break;
      case 252: /* "GroupOrUnionGraphPatternList" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3415 "sparql_parser.c"
	break;
      case 253: /* "LetGraphPattern" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3427 "sparql_parser.c"
	break;
      case 254: /* "BindGraphPattern" */

/* Line 1000 of yacc.c  */
#line 402 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3439 "sparql_parser.c"
	break;
      case 255: /* "Filter" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3451 "sparql_parser.c"
	break;
      case 256: /* "Constraint" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3463 "sparql_parser.c"
	break;
      case 257: /* "ParamsOpt" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3475 "sparql_parser.c"
	break;
      case 258: /* "FunctionCall" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3487 "sparql_parser.c"
	break;
      case 259: /* "CoalesceExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3499 "sparql_parser.c"
	break;
      case 260: /* "ArgList" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3511 "sparql_parser.c"
	break;
      case 261: /* "ArgListNoBraces" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3523 "sparql_parser.c"
	break;
      case 262: /* "ConstructTemplate" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3535 "sparql_parser.c"
	break;
      case 263: /* "ConstructTriplesOpt" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3547 "sparql_parser.c"
	break;
      case 264: /* "ConstructTriples" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3559 "sparql_parser.c"
	break;
      case 265: /* "TriplesSameSubject" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3571 "sparql_parser.c"
	break;
      case 266: /* "PropertyListNotEmpty" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3583 "sparql_parser.c"
	break;
      case 267: /* "PropertyListTailOpt" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3595 "sparql_parser.c"
	break;
      case 268: /* "PropertyList" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3607 "sparql_parser.c"
	break;
      case 269: /* "ObjectList" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3619 "sparql_parser.c"
	break;
      case 270: /* "ObjectTail" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3631 "sparql_parser.c"
	break;
      case 271: /* "Object" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3643 "sparql_parser.c"
	break;
      case 272: /* "Verb" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3655 "sparql_parser.c"
	break;
      case 273: /* "TriplesNode" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3667 "sparql_parser.c"
	break;
      case 274: /* "BlankNodePropertyList" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3679 "sparql_parser.c"
	break;
      case 275: /* "Collection" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3691 "sparql_parser.c"
	break;
      case 276: /* "GraphNodeListNotEmpty" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3703 "sparql_parser.c"
	break;
      case 277: /* "GraphNode" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3715 "sparql_parser.c"
	break;
      case 278: /* "VarOrTerm" */

/* Line 1000 of yacc.c  */
#line 391 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3727 "sparql_parser.c"
	break;
      case 279: /* "VarOrIRIref" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3739 "sparql_parser.c"
	break;
      case 280: /* "Var" */

/* Line 1000 of yacc.c  */
#line 441 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 3751 "sparql_parser.c"
	break;
      case 281: /* "VarName" */

/* Line 1000 of yacc.c  */
#line 441 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 3763 "sparql_parser.c"
	break;
      case 283: /* "GraphTerm" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3775 "sparql_parser.c"
	break;
      case 284: /* "Expression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3787 "sparql_parser.c"
	break;
      case 285: /* "ConditionalOrExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3799 "sparql_parser.c"
	break;
      case 286: /* "ConditionalAndExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3811 "sparql_parser.c"
	break;
      case 287: /* "RelationalExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3823 "sparql_parser.c"
	break;
      case 288: /* "AdditiveExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3835 "sparql_parser.c"
	break;
      case 289: /* "MultiplicativeExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3847 "sparql_parser.c"
	break;
      case 290: /* "UnaryExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3859 "sparql_parser.c"
	break;
      case 291: /* "PrimaryExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3871 "sparql_parser.c"
	break;
      case 292: /* "BrackettedExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3883 "sparql_parser.c"
	break;
      case 293: /* "BuiltInCall" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3895 "sparql_parser.c"
	break;
      case 295: /* "RegexExpression" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3907 "sparql_parser.c"
	break;
      case 296: /* "DatetimeBuiltinAccessors" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3919 "sparql_parser.c"
	break;
      case 297: /* "DatetimeExtensions" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3931 "sparql_parser.c"
	break;
      case 298: /* "IRIrefBrace" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3943 "sparql_parser.c"
	break;
      case 299: /* "NumericLiteral" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3955 "sparql_parser.c"
	break;
      case 300: /* "NumericLiteralUnsigned" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3967 "sparql_parser.c"
	break;
      case 301: /* "NumericLiteralPositive" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3979 "sparql_parser.c"
	break;
      case 302: /* "NumericLiteralNegative" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3991 "sparql_parser.c"
	break;
      case 303: /* "IRIref" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 4003 "sparql_parser.c"
	break;
      case 304: /* "BlankNode" */

/* Line 1000 of yacc.c  */
#line 430 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 4015 "sparql_parser.c"
	break;

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:

/* Line 1455 of yacc.c  */
#line 494 "./sparql_parser.y"
    {
  if((yyvsp[(4) - (4)].bindings))
    ((rasqal_query*)rq)->bindings = (yyvsp[(4) - (4)].bindings);
}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 503 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(sparql->experimental)
    ((rasqal_query*)rq)->explain = 1;
  else {
    sparql_syntax_error((rasqal_query*)rq, 
                        "EXPLAIN can only used with LAQRS");
    YYERROR;
  }
}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 516 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 524 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->selects = (yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_SELECT;
}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 529 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->constructs = (yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_CONSTRUCT;
}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 534 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->describes = (yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_DESCRIBE;
}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 539 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_ASK;
}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 557 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_DELETE;
}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 561 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_INSERT;
}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 565 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 569 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 573 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 577 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 581 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 585 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 589 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 593 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 601 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 609 "./sparql_parser.y"
    {
  rasqal_query_set_base_uri((rasqal_query*)rq, (yyvsp[(2) - (2)].uri));
}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 613 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 621 "./sparql_parser.y"
    {
  raptor_sequence *seq = ((rasqal_query*)rq)->prefixes;
  unsigned const char* prefix_string = (yyvsp[(3) - (4)].name);
  size_t l = 0;

  if(prefix_string)
    l=strlen((const char*)prefix_string);
  
  if(raptor_namespaces_find_namespace(((rasqal_query*)rq)->namespaces,
                                      prefix_string, l)) {
    /* A prefix may be defined only once */
    sparql_syntax_warning(((rasqal_query*)rq), 
                          "PREFIX %s can be defined only once.",
                          prefix_string ? (const char*)prefix_string : ":");
    RASQAL_FREE(cstring, prefix_string);
    raptor_free_uri((yyvsp[(4) - (4)].uri));
  } else {
    rasqal_prefix *p;
    p = rasqal_new_prefix(((rasqal_query*)rq)->world, prefix_string, (yyvsp[(4) - (4)].uri));
    if(!p)
      YYERROR_MSG("PrefixDeclOpt: failed to create new prefix");
    if(raptor_sequence_push(seq, p))
      YYERROR_MSG("PrefixDeclOpt: cannot push prefix to seq");
    if(rasqal_query_declare_prefix(((rasqal_query*)rq), p)) {
      YYERROR_MSG("PrefixDeclOpt: cannot declare prefix");
    }
  }
}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 650 "./sparql_parser.y"
    {
  /* nothing to do, rq->prefixes already initialised */
}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 658 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.seq) = NULL;
  if(!sparql->sparql_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SELECT can only be used with a SPARQL query");
    YYERROR;
  } else {
    /* FIXME - this peeks inside rasqal_projection */
    (yyval.seq) = (yyvsp[(1) - (4)].projection)->variables; (yyvsp[(1) - (4)].projection)->variables = NULL;
    if((yyvsp[(1) - (4)].projection)->wildcard)
      ((rasqal_query*)rq)->wildcard = 1;
    ((rasqal_query*)rq)->distinct = (yyvsp[(1) - (4)].projection)->distinct;
    rasqal_free_projection((yyvsp[(1) - (4)].projection));

    if((yyvsp[(2) - (4)].seq))
      rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (4)].seq));

    ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (4)].graph_pattern);

    if((yyvsp[(4) - (4)].modifier))
      ((rasqal_query*)rq)->modifier = (yyvsp[(4) - (4)].modifier);
  }
}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 688 "./sparql_parser.y"
    {
  if((yyvsp[(1) - (3)].projection) && (yyvsp[(2) - (3)].graph_pattern) && (yyvsp[(3) - (3)].modifier))
    (yyval.graph_pattern) = rasqal_new_select_graph_pattern((rasqal_query*)rq,
                                         (yyvsp[(1) - (3)].projection), (yyvsp[(2) - (3)].graph_pattern), (yyvsp[(3) - (3)].modifier));
  else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 699 "./sparql_parser.y"
    {
  (yyval.projection) = (yyvsp[(3) - (3)].projection);
  (yyval.projection)->distinct = 1;
}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 704 "./sparql_parser.y"
    {
  (yyval.projection) = (yyvsp[(3) - (3)].projection);
  (yyval.projection)->distinct = 2;
}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 709 "./sparql_parser.y"
    {
  (yyval.projection) = (yyvsp[(2) - (2)].projection);
}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 719 "./sparql_parser.y"
    {
  (yyval.projection) = rasqal_new_projection((rasqal_query*)rq, (yyvsp[(1) - (1)].seq), 0, 0);
}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 723 "./sparql_parser.y"
    {
  (yyval.projection) = rasqal_new_projection((rasqal_query*)rq, NULL, /* wildcard */ 1, 0);
}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 733 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 1: sequence push failed");
  }
}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 742 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 2: sequence push failed");
  }
}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 751 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_variable,
                           (raptor_data_print_handler)rasqal_variable_print);
  if(!(yyval.seq))
    YYERROR_MSG("SelectExpressionListTail 3: failed to create sequence");
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 3: sequence push failed");
  }
}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 769 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(1) - (1)].variable);
}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 773 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.variable) = NULL;
  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SELECT ( expression ) AS Variable cannot be used with SPARQL 1.0");
    YYERROR;
  } else if((yyvsp[(2) - (5)].expr) && (yyvsp[(4) - (5)].variable)) {
    if(rasqal_expression_mentions_variable((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].variable))) {
      sparql_query_error_full((rasqal_query*)rq, 
                              "Expression in SELECT ( expression ) AS %s contains the variable name '%s'",
                              (yyvsp[(4) - (5)].variable)->name, (yyvsp[(4) - (5)].variable)->name);
      YYERROR;
    } else {
      (yyval.variable) = (yyvsp[(4) - (5)].variable);
      (yyval.variable)->expression = (yyvsp[(2) - (5)].expr);
    }

  }
}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 815 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 819 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 823 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 827 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 831 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 835 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 839 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 846 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "functions with DISTINCT cannot be used with SPARQL 1.0");
    YYERROR;
  }
  
  (yyval.uinteger) = RASQAL_EXPR_FLAG_DISTINCT;
}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 859 "./sparql_parser.y"
    {
  (yyval.uinteger) = 0;
}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 866 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 870 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_0op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_VARSTAR);
}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 878 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "COUNT() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_COUNT, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("CountAggregateExpression: cannot create expr");
  }
}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 899 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SUM() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_SUM, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("SumAggregateExpression: cannot create expr");
  }
}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 920 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "AVG() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_AVG, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("AvgAggregateExpression: cannot create expr");
  }
}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 941 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "MIN() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_MIN, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("MinAggregateExpression: cannot create expr");
  }
}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 962 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "MAX() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_MAX, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("MaxAggregateExpression: cannot create expr");
  }
}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 983 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_string_literal(((rasqal_query*)rq)->world, (yyvsp[(4) - (4)].name), 
	                         NULL /* language */,
                                 NULL /* dt uri */, NULL /* dt_qname */);
}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 989 "./sparql_parser.y"
    {
  (yyval.literal) = NULL;
}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 999 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].expr))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("ExpressionList 1: sequence push failed");
  }
}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 1008 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
  if(!(yyval.seq))
    YYERROR_MSG("ExpressionList 2: failed to create sequence");

  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("ExpressionList 2: sequence push failed");
  }
}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 1024 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "GROUP_CONCAT() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    int flags = 0;
    
    if((yyvsp[(3) - (6)].uinteger))
      flags |= RASQAL_EXPR_FLAG_DISTINCT;

    (yyval.expr) = rasqal_new_group_concat_expression(((rasqal_query*)rq)->world,
                                            flags /* flags */,
                                            (yyvsp[(4) - (6)].seq) /* args */,
                                            (yyvsp[(5) - (6)].literal) /* separator */);
    if(!(yyval.expr))
      YYERROR_MSG("GroupConcatAggregateExpression: cannot create expr");
  }
}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 1052 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SAMPLE() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_SAMPLE, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("SampleAggregateExpression: cannot create expr");
  }
}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 1075 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.seq) = NULL;
  if(!sparql->sparql_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "CONSTRUCT can only be used with a SPARQL query");
    YYERROR;
  }
  
  (yyval.seq) = (yyvsp[(2) - (5)].seq);

  if((yyvsp[(3) - (5)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(3) - (5)].seq));
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);

  if((yyvsp[(5) - (5)].modifier))
    ((rasqal_query*)rq)->modifier = (yyvsp[(5) - (5)].modifier);
}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 1102 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.seq) = NULL;
  if(!sparql->sparql_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "DESCRIBE can only be used with a SPARQL query");
    YYERROR;
  }
  
  (yyval.seq) = (yyvsp[(2) - (5)].seq);

  if((yyvsp[(3) - (5)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(3) - (5)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);

  if((yyvsp[(5) - (5)].modifier))
    ((rasqal_query*)rq)->modifier = (yyvsp[(5) - (5)].modifier);
}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 1126 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;

  if((yyvsp[(3) - (5)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(3) - (5)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);

  if((yyvsp[(5) - (5)].modifier))
    ((rasqal_query*)rq)->modifier = (yyvsp[(5) - (5)].modifier);
}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 1142 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 1: sequence push failed");
  }
}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 1151 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 2: sequence push failed");
  }
}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 1160 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_literal,
                           (raptor_data_print_handler)rasqal_literal_print);
  if(!(yyval.seq))
    YYERROR_MSG("VarOrIRIrefList 3: cannot create seq");
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 3: sequence push failed");
  }
}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 1177 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "ASK can only be used with a SPARQL query");
    YYERROR;
  }
  
  if((yyvsp[(2) - (3)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (3)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 1197 "./sparql_parser.y"
    {
  (yyval.data_graph) = (yyvsp[(2) - (2)].data_graph);
}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 1201 "./sparql_parser.y"
    {
  (yyval.data_graph) = (yyvsp[(2) - (2)].data_graph);
}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 1209 "./sparql_parser.y"
    {
  (yyval.uri) = (yyvsp[(2) - (2)].uri);
}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 1217 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  /* LAQRS: experimental syntax */
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "DELETE FROM <uri> ... WHERE ... is deprecated LAQRS syntax.");

  if((yyvsp[(2) - (3)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (3)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 1237 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* SPARQL 1.1 (Draft) update:
   * deleting via template + query - not inline atomic triples 
   */

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph_uri */,
                                       NULL /* document_uri */,
                                       NULL /* insert templates */,
                                       (yyvsp[(3) - (5)].seq) /* delete templates */,
                                       (yyvsp[(5) - (5)].graph_pattern) /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("DeleteQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DeleteQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 1269 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  /* SPARQL 1.1 (Draft) update:
   * deleting inline triples - not inserting from graph URIs 
   */
  (yyvsp[(4) - (5)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(4) - (5)].update)->delete_templates = (yyvsp[(4) - (5)].update)->insert_templates; (yyvsp[(4) - (5)].update)->insert_templates = NULL;
  (yyvsp[(4) - (5)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;
  
  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(4) - (5)].update));
}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 1289 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;
  raptor_sequence* delete_templates = NULL;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE WHERE { } can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* SPARQL 1.1 (Draft) update:
   * deleting via template - not inline atomic triples 
   */

  /* Turn GP into flattened triples */
  if((yyvsp[(3) - (3)].graph_pattern)) {
    delete_templates = rasqal_graph_pattern_get_flattened_triples((rasqal_query*)rq, (yyvsp[(3) - (3)].graph_pattern));
    rasqal_free_graph_pattern((yyvsp[(3) - (3)].graph_pattern));
    (yyvsp[(3) - (3)].graph_pattern) = NULL;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph_uri */,
                                       NULL /* document_uri */,
                                       NULL /* insert templates */,
                                       delete_templates /* delete templates */,
                                       NULL /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("DeleteQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DeleteQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1333 "./sparql_parser.y"
    {
  (yyval.update) = NULL;
 
  if((yyvsp[(1) - (1)].formula)) {
    (yyval.update) = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UNKNOWN,
                                     NULL /* graph_uri */,
                                     NULL /* document_uri */,
                                     (yyvsp[(1) - (1)].formula)->triples /* insert templates */, 
                                     NULL /* delete templates */,
                                     NULL /* where */,
                                     0 /* flags */,
                                     RASQAL_UPDATE_GRAPH_ONE /* applies */);
    (yyvsp[(1) - (1)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (1)].formula));
  }
}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 1350 "./sparql_parser.y"
    {
  (yyval.update) = NULL;

  if((yyvsp[(4) - (5)].formula)) {
    raptor_sequence* seq;
    seq = (yyvsp[(4) - (5)].formula)->triples;

    if((yyvsp[(2) - (5)].uri)) {
      rasqal_literal* origin_literal;
      
      origin_literal = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(2) - (5)].uri));
      (yyvsp[(2) - (5)].uri) = NULL;

      rasqal_triples_sequence_set_origin(/* dest */ NULL, seq, origin_literal);
      rasqal_free_literal(origin_literal);
    }
    (yyval.update) = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UNKNOWN,
                                     NULL /* graph uri */,
                                     NULL /* document uri */,
                                     seq /* insert templates */,
                                     NULL /* delete templates */,
                                     NULL /* where */,
                                     0 /* flags */,
                                     RASQAL_UPDATE_GRAPH_ONE /* applies */);
    (yyvsp[(4) - (5)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(4) - (5)].formula));
  }
}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1383 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(4) - (5)].seq);

  if((yyvsp[(2) - (5)].literal)) {
    rasqal_triples_sequence_set_origin(NULL, (yyval.seq), (yyvsp[(2) - (5)].literal));
    rasqal_free_literal((yyvsp[(2) - (5)].literal));
    (yyvsp[(2) - (5)].literal) = NULL;
  }
}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1398 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1402 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1410 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);

  if((yyvsp[(2) - (2)].seq)) {
    if(raptor_sequence_join((yyval.seq), (yyvsp[(2) - (2)].seq))) {
      raptor_free_sequence((yyvsp[(2) - (2)].seq));
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ModifyTemplateList: sequence join failed");
    }
    raptor_free_sequence((yyvsp[(2) - (2)].seq));
  }

}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1425 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1434 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql  = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* LAQRS: experimental syntax */
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "INSERT FROM <uri> ... WHERE ... is deprecated LAQRS syntax.");

  if((yyvsp[(2) - (3)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (3)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1454 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  /* inserting via template + query - not inline atomic triples */

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph_uri */,
                                       NULL /* document_uri */,
                                       (yyvsp[(3) - (5)].seq) /* insert templates */,
                                       NULL /* delete templates */,
                                       (yyvsp[(5) - (5)].graph_pattern) /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("InsertQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("InsertQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 1484 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT DATA can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  /* inserting inline atomic triples (no variables) - not via template */
  (yyvsp[(4) - (5)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(4) - (5)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;

  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(4) - (5)].update));
}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1507 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "WITH can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  if((yyvsp[(2) - (11)].uri)) {
    rasqal_literal* origin_literal;

    origin_literal = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(2) - (11)].uri));
    (yyvsp[(2) - (11)].uri) = NULL;

    rasqal_triples_sequence_set_origin(/* dest */ NULL, (yyvsp[(9) - (11)].seq), origin_literal);
    rasqal_triples_sequence_set_origin(/* dest */ NULL, (yyvsp[(5) - (11)].seq), origin_literal);

    rasqal_free_literal(origin_literal);
  }

  /* after this $5, $9 and $12 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph uri */, 
                                       NULL /* document uri */,
                                       (yyvsp[(9) - (11)].seq) /* insert templates */,
                                       (yyvsp[(5) - (11)].seq) /* delete templates */,
                                       (yyvsp[(11) - (11)].graph_pattern) /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 1: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 1: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1550 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "WITH can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  if((yyvsp[(2) - (7)].uri)) {
    rasqal_literal* origin_literal;
    
    origin_literal = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(2) - (7)].uri));
    (yyvsp[(2) - (7)].uri) = NULL;

    rasqal_triples_sequence_set_origin(/* dest */ NULL, (yyvsp[(5) - (7)].seq), origin_literal);

    rasqal_free_literal(origin_literal);
  }
  
  /* after this $5 and $7 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL /* insert templates */,
                                       (yyvsp[(5) - (7)].seq) /* delete templates */,
                                       (yyvsp[(7) - (7)].graph_pattern) /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 2: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 2: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1592 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "WITH can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  if((yyvsp[(2) - (7)].uri)) {
    rasqal_literal* origin_literal;
    
    origin_literal = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(2) - (7)].uri));
    (yyvsp[(2) - (7)].uri) = NULL;

    rasqal_triples_sequence_set_origin(/* dest */ NULL, (yyvsp[(5) - (7)].seq), origin_literal);

    rasqal_free_literal(origin_literal);
  }

  /* after this $5 and $7 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph uri */, 
                                       NULL /* document uri */,
                                       (yyvsp[(5) - (7)].seq) /* insert templates */,
                                       NULL /* delete templates */,
                                       (yyvsp[(7) - (7)].graph_pattern) /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 3: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 3: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 1633 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "WITH can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* inserting inline atomic triples (no variables) - not via template */
  (yyvsp[(6) - (7)].update)->graph_uri = (yyvsp[(2) - (7)].uri); /* graph uri */
  (yyvsp[(6) - (7)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(6) - (7)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;

  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(6) - (7)].update));
}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1656 "./sparql_parser.y"
    {
  (yyval.uri_applies) = new_uri_applies((yyvsp[(1) - (1)].uri), RASQAL_UPDATE_GRAPH_ONE);
}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1660 "./sparql_parser.y"
    {
  (yyval.uri_applies) = new_uri_applies(NULL, RASQAL_UPDATE_GRAPH_DEFAULT);
}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1664 "./sparql_parser.y"
    {
  (yyval.uri_applies) = new_uri_applies(NULL, RASQAL_UPDATE_GRAPH_NAMED);
}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1668 "./sparql_parser.y"
    {
  (yyval.uri_applies) = new_uri_applies(NULL, RASQAL_UPDATE_GRAPH_ALL);
}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1672 "./sparql_parser.y"
    {
  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CLEAR GRAPH DEFAULT is replaced by CLEAR DEFAULT in later SPARQL 1.1 drafts");


  (yyval.uri_applies) = new_uri_applies(NULL, RASQAL_UPDATE_GRAPH_DEFAULT);
}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1685 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "CLEAR (SILENT) DEFAULT | NAMED | ALL can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CLEAR,
                                       (yyvsp[(3) - (3)].uri_applies)->uri ? raptor_uri_copy((yyvsp[(3) - (3)].uri_applies)->uri) : NULL /* graph uri or NULL */,
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       (yyvsp[(2) - (3)].integer) /* flags */,
                                       (yyvsp[(3) - (3)].uri_applies)->applies /* applies */);
  free_uri_applies((yyvsp[(3) - (3)].uri_applies));
  if(update)
    update->applies = (rasqal_update_graph_applies)(yyvsp[(3) - (3)].uri_applies);
  
  if(!update) {
    YYERROR_MSG("ClearQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("ClearQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1716 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "CLEAR can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CLEAR is replaced by CLEAR DEFAULT in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CLEAR,
                                       NULL /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("ClearQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("ClearQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1751 "./sparql_parser.y"
    {
  (yyval.integer) = RASQAL_UPDATE_FLAGS_SILENT;
}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1755 "./sparql_parser.y"
    {
  (yyval.integer) = 0;
}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1763 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE (SILENT) <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       (yyvsp[(2) - (3)].integer) /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1790 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE (SILENT) GRAPH <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CREATE (SILENT) GRAPH <uri> is replaced by CREATE (SILENT) <uri> in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       RASQAL_UPDATE_FLAGS_SILENT /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1825 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq, 
                        "DROP (SILENT) DEFAULT | NAMED | ALL can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_DROP,
                                       raptor_uri_copy((yyvsp[(3) - (3)].uri_applies)->uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       (yyvsp[(2) - (3)].integer) /* flags */,
                                       (yyvsp[(3) - (3)].uri_applies)->applies /* applies */);
  free_uri_applies((yyvsp[(3) - (3)].uri_applies));
  if(!update) {
    YYERROR_MSG("DropQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DropQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1857 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].uri))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 1: sequence push failed");
  }
}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1866 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)raptor_free_uri,
                           (raptor_data_print_handler)raptor_uri_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].uri))
      raptor_free_uri((yyvsp[(1) - (1)].uri));
    YYERROR_MSG("IriRefList 2: cannot create sequence");
  }
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].uri))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 2: sequence push failed");
  }
}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1885 "./sparql_parser.y"
    {
  (yyval.uri) = NULL;
}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1889 "./sparql_parser.y"
    {
  (yyval.uri) = (yyvsp[(1) - (1)].uri);
}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1896 "./sparql_parser.y"
    {
  (yyval.uri) = (yyvsp[(1) - (1)].uri);
}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1900 "./sparql_parser.y"
    {
  /* Early draft syntax allowed a list of URIs - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "LOAD <document uri list> INTO <graph uri> is replaced by LOAD <document uri> INTO GRAPH <graph uri> in later SPARQL 1.1 drafts");

  (yyval.uri) = (yyvsp[(1) - (1)].uri);
}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1908 "./sparql_parser.y"
    {
  /* Early draft syntax allowed a list of URIs - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "LOAD <document uri list> INTO DEFAULT is replaced by LOAD <document uri> in later SPARQL 1.1 drafts");

  (yyval.uri) = NULL;
}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1920 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq, 
                        "LOAD <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_LOAD,
                                       NULL /* graph uri */, 
                                       (yyvsp[(3) - (3)].uri) /* document uri */,
                                       NULL, NULL,
                                       NULL /* where */,
                                       (yyvsp[(2) - (3)].integer) /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("LoadQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("LoadQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1947 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  int i;
  raptor_uri* doc_uri;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq, 
                        "LOAD <document uri> INTO GRAPH <graph URI> / DEFAULT can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  for(i = 0; (doc_uri = (raptor_uri*)raptor_sequence_get_at((yyvsp[(3) - (5)].seq), i)); i++) {
    rasqal_update_operation* update;
    update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_LOAD,
                                         (yyvsp[(5) - (5)].uri) ? raptor_uri_copy((yyvsp[(5) - (5)].uri)) : NULL /* graph uri */,
                                         raptor_uri_copy(doc_uri) /* document uri */,
                                         NULL, NULL,
                                         NULL /*where */,
                                         (yyvsp[(2) - (5)].integer) /* flags */,
                                         RASQAL_UPDATE_GRAPH_ONE /* applies */);
    if(!update) {
      YYERROR_MSG("LoadQuery: rasqal_new_update_operation failed");
    } else {
      if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
        YYERROR_MSG("LoadQuery: rasqal_query_add_update_operation failed");
    }

    if(i == 1)
      /* Early draft syntax allowed a list of URIs - deprecated */
      sparql_syntax_warning((rasqal_query*)rq,
                            "LOAD <document uri list> INTO <graph uri> / DEFAULT is replaced by LOAD <document uri> INTO GRAPH <graph uri> or LOAD <document uri> in later SPARQL 1.1 drafts");
    

  }

  raptor_free_sequence((yyvsp[(3) - (5)].seq));
  if((yyvsp[(5) - (5)].uri))
    raptor_free_uri((yyvsp[(5) - (5)].uri));
}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1993 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "ADD (SILENT) <uri> TO <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_ADD,
                                       (yyvsp[(3) - (5)].uri) /* graph uri or NULL */, 
                                       (yyvsp[(5) - (5)].uri) /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       (yyvsp[(2) - (5)].integer) /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("AddQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("AddQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 2024 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "MOVE (SILENT) <uri> TO <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_MOVE,
                                       (yyvsp[(3) - (5)].uri) /* graph uri or NULL */, 
                                       (yyvsp[(5) - (5)].uri) /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       (yyvsp[(2) - (5)].integer) /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("MoveQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("MoveQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 2055 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "COPY (SILENT) <uri> TO <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_COPY,
                                       (yyvsp[(3) - (5)].uri) /* graph uri or NULL */, 
                                       (yyvsp[(5) - (5)].uri) /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       (yyvsp[(2) - (5)].integer) /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("CopyQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CopyQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 2086 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(1) - (2)].seq) && (yyvsp[(2) - (2)].data_graph))
    raptor_sequence_push((yyvsp[(1) - (2)].seq), (yyvsp[(2) - (2)].data_graph));
}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 2092 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_data_graph, (raptor_data_print_handler)rasqal_data_graph_print);
  if((yyval.seq) && (yyvsp[(1) - (1)].data_graph))
    raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].data_graph));
}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 2101 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 2105 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 2113 "./sparql_parser.y"
    {
  if((yyvsp[(1) - (1)].literal)) {
    raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (1)].literal));
    rasqal_data_graph* dg;

    dg = rasqal_new_data_graph_from_uri(((rasqal_query*)rq)->world, uri,
                                        NULL, RASQAL_DATA_GRAPH_BACKGROUND,
                                        NULL, NULL, NULL);

    if(!dg) {
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
      YYERROR_MSG("DefaultGraphClause: rasqal_query_new_data_graph_from_uri() failed");
    }
    rasqal_free_literal((yyvsp[(1) - (1)].literal));

    (yyval.data_graph) = dg;
  } else
    (yyval.data_graph) = NULL;
}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 2137 "./sparql_parser.y"
    {
  if((yyvsp[(2) - (2)].literal)) {
    raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(2) - (2)].literal));
    rasqal_data_graph* dg;

    dg = rasqal_new_data_graph_from_uri(((rasqal_query*)rq)->world, uri,
                                        uri, RASQAL_DATA_GRAPH_NAMED,
                                        NULL, NULL, NULL);
    
    if(!dg) {
      rasqal_free_literal((yyvsp[(2) - (2)].literal));
      YYERROR_MSG("NamedGraphClause: rasqal_query_new_data_graph_from_uri() failed");
    }
    rasqal_free_literal((yyvsp[(2) - (2)].literal));
    (yyval.data_graph) = dg;
  } else
    (yyval.data_graph) = NULL;
}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 2160 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 2168 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(2) - (2)].graph_pattern);
}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 2172 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 2180 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 2184 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = NULL;
}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 2192 "./sparql_parser.y"
    {
  (yyval.modifier) = rasqal_new_solution_modifier((rasqal_query*)rq,
                                    /* order_conditions */ (yyvsp[(3) - (4)].seq),
                                    /* group_conditions */ (yyvsp[(1) - (4)].seq),
                                    /* having_conditions */ (yyvsp[(2) - (4)].seq),
                                    /* limit */ (yyvsp[(4) - (4)].limit_offset)[0],
                                    /* offset */ (yyvsp[(4) - (4)].limit_offset)[1]);
  
}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 2206 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GroupConditionList 1: sequence push failed");
    }
}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 2216 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("GroupConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GroupConditionList 2: sequence push failed");
    }
}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 2236 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 2240 "./sparql_parser.y"
    {
  (yyval.variable) = NULL;
}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 2248 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 2252 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 2256 "./sparql_parser.y"
    {
  rasqal_literal* l;

  (yyval.expr) = (yyvsp[(2) - (4)].expr);
  if((yyvsp[(3) - (4)].variable)) {
    if(rasqal_expression_mentions_variable((yyval.expr), (yyvsp[(3) - (4)].variable))) {
      sparql_query_error_full((rasqal_query*)rq, 
                              "Expression in GROUP BY ( expression ) AS %s contains the variable name '%s'",
                              (yyvsp[(3) - (4)].variable)->name, (yyvsp[(3) - (4)].variable)->name);
    } else {
      /* Expression AS Variable */
      (yyvsp[(3) - (4)].variable)->expression = (yyval.expr);
      (yyval.expr) = NULL;
      
      l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(3) - (4)].variable));
      if(!l)
        YYERROR_MSG("GroupCondition 4: cannot create variable literal");
      (yyvsp[(3) - (4)].variable) = NULL;

      (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
      if(!(yyval.expr))
        YYERROR_MSG("GroupCondition 4: cannot create variable literal expression");
    }
  }
  
}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 2283 "./sparql_parser.y"
    {
  rasqal_literal* l;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("GroupCondition 5: cannot create lit");
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!(yyval.expr))
    YYERROR_MSG("GroupCondition 5: cannot create lit expr");
}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 2297 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.seq) = NULL;
  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "GROUP BY cannot be used with SPARQL 1.0");
    YYERROR;
  } else
    (yyval.seq) = (yyvsp[(3) - (3)].seq);
}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 2310 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 2318 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 2325 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("HavingConditionList 1: sequence push failed");
    }
}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 2335 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("HavingConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("HavingConditionList 2: sequence push failed");
    }
}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 2355 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.seq) = NULL;
  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "HAVING cannot be used with SPARQL 1.0");
    YYERROR;
  } else 
    (yyval.seq) = (yyvsp[(2) - (2)].seq);
}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 2368 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 2376 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = (yyvsp[(1) - (2)].integer);
  (yyval.limit_offset)[1] = (yyvsp[(2) - (2)].integer);
}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 2381 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = (yyvsp[(2) - (2)].integer);
  (yyval.limit_offset)[1] = (yyvsp[(1) - (2)].integer);
}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 2386 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = (yyvsp[(1) - (1)].integer);
  (yyval.limit_offset)[1] = -1;
}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 2391 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = -1;
  (yyval.limit_offset)[1] = (yyvsp[(1) - (1)].integer);
}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 2396 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = -1;
  (yyval.limit_offset)[1] = -1;
}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 2405 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(3) - (3)].seq);
}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 2409 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 2417 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("OrderConditionList 1: sequence push failed");
    }
}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 2427 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("OrderConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("OrderConditionList 2: sequence push failed");
    }
}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 2447 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 1: cannot create expr");
}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 2454 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_DESC, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 2: cannot create expr");
}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 2461 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 3: cannot create expr");
}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 2469 "./sparql_parser.y"
    {
  rasqal_literal* l;
  rasqal_expression *e;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("OrderCondition 4: cannot create lit");
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!e)
    YYERROR_MSG("OrderCondition 4: cannot create lit expr");

  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, e);
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 1: cannot create expr");
}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 2486 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 5: cannot create expr");
}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 2494 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 6: cannot create expr");
}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 2506 "./sparql_parser.y"
    {
  (yyval.integer) = -1;

  if((yyvsp[(2) - (2)].literal) != NULL) {
    (yyval.integer) = (yyvsp[(2) - (2)].literal)->value.integer;
    rasqal_free_literal((yyvsp[(2) - (2)].literal));
  }
  
}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 2520 "./sparql_parser.y"
    {
  (yyval.integer) = -1;

  if((yyvsp[(2) - (2)].literal) != NULL) {
    (yyval.integer) = (yyvsp[(2) - (2)].literal)->value.integer;
    rasqal_free_literal((yyvsp[(2) - (2)].literal));
  }
}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 2533 "./sparql_parser.y"
    {
  if((yyvsp[(2) - (5)].seq)) {
    (yyval.bindings) = rasqal_new_bindings((rasqal_query*)rq, (yyvsp[(2) - (5)].seq), (yyvsp[(4) - (5)].seq));
    if(!(yyval.bindings))
      YYERROR_MSG("BindingsClauseOpt: cannot create bindings");
  } else {
    if((yyvsp[(4) - (5)].seq))
      raptor_free_sequence((yyvsp[(4) - (5)].seq));

    (yyval.bindings) = NULL;
  }
}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 2546 "./sparql_parser.y"
    {
  (yyval.bindings) = NULL;
}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 2554 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarList 1: sequence push failed");
  }
}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 2563 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_variable,
                           (raptor_data_print_handler)rasqal_variable_print);
  if(!(yyval.seq))
    YYERROR_MSG("VarList 2: cannot create seq");

  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarList 3: sequence push failed");
  }
}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 2580 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 2584 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 2592 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].row))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("BindingsRowList 1: sequence push failed");
  } else {
    int size = raptor_sequence_size((yyval.seq));
    (yyvsp[(2) - (2)].row)->offset = size-1;
  }
}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 2604 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_row,
                           (raptor_data_print_handler)rasqal_row_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].row))
      rasqal_free_row((yyvsp[(1) - (1)].row));

    YYERROR_MSG("BindingsRowList 2: cannot create sequence");
  }
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].row))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("BindingsRowList 2: sequence push failed");
  }
}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 2624 "./sparql_parser.y"
    {
  (yyval.row) = NULL;
  if((yyvsp[(2) - (3)].seq)) {
    int size;
    rasqal_row* row;
    int i;
    
    size = raptor_sequence_size((yyvsp[(2) - (3)].seq));

    row = rasqal_new_row_for_size(((rasqal_query*)rq)->world, size);
    if(!row) {
      YYERROR_MSG("BindingsRow: cannot create row");
    } else {
      for(i = 0; i < size; i++) {
        rasqal_literal* value = raptor_sequence_delete_at((yyvsp[(2) - (3)].seq), i);
        rasqal_row_set_value_at(row, i, value);
      }
    }
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
    
    (yyval.row) = row;
  }
}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 2648 "./sparql_parser.y"
    {
  (yyval.row) = NULL;
}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 2656 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 1: sequence push failed");
  }
}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 2665 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_literal,
                           (raptor_data_print_handler)rasqal_literal_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("IriRefList 2: cannot create sequence");
  }
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 2: sequence push failed");
  }
}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 2683 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_string_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].name), 
	                         NULL /* language */,
                                 NULL /* dt uri */, NULL /* dt_qname */);
}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 2689 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_string_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (2)].name), 
	                         (const char*)(yyvsp[(2) - (2)].name),
                                 NULL /* dt uri */, NULL /* dt_qname */);
}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 2695 "./sparql_parser.y"
    {
  raptor_uri* dt_uri = raptor_uri_copy(rasqal_literal_as_uri((yyvsp[(3) - (3)].literal)));
  (yyval.literal) = rasqal_new_string_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (3)].name), 
	                         NULL /* language */,
                                 dt_uri, NULL /* dt_qname */);
  rasqal_free_literal((yyvsp[(3) - (3)].literal));
}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 2707 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 2711 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 2715 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 2719 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 2723 "./sparql_parser.y"
    {
  (yyval.literal) = NULL;
}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 2734 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(2) - (3)].graph_pattern);
}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 2738 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(2) - (3)].graph_pattern);
}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 2749 "./sparql_parser.y"
    {
  rasqal_graph_pattern *formula_gp = NULL;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GroupGraphPattern\n  TriplesBlockOpt=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", GraphpatternListOpt=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif


  if(!(yyvsp[(1) - (2)].formula) && !(yyvsp[(2) - (2)].graph_pattern)) {
    (yyval.graph_pattern) = rasqal_new_2_group_graph_pattern((rasqal_query*)rq, NULL, NULL);
    if(!(yyval.graph_pattern))
      YYERROR_MSG("GroupGraphPattern: cannot create group gp");
  } else {
    if((yyvsp[(1) - (2)].formula)) {
      formula_gp = rasqal_new_basic_graph_pattern_from_formula((rasqal_query*)rq,
                                                               (yyvsp[(1) - (2)].formula));
      if(!formula_gp) {
        if((yyvsp[(2) - (2)].graph_pattern))
          rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
        YYERROR_MSG("GroupGraphPattern: cannot create formula_gp");
      }
    }

    if((yyvsp[(2) - (2)].graph_pattern)) {
      (yyval.graph_pattern) = (yyvsp[(2) - (2)].graph_pattern);
      if(formula_gp && raptor_sequence_shift((yyval.graph_pattern)->graph_patterns, formula_gp)) {
        rasqal_free_graph_pattern((yyval.graph_pattern));
        (yyval.graph_pattern) = NULL;
        YYERROR_MSG("GroupGraphPattern: sequence push failed");
      }
    } else
      (yyval.graph_pattern) = formula_gp;
  }
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 2807 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesBlockOpt 1\n  TriplesBlock=");
  if((yyvsp[(1) - (1)].formula))
    rasqal_formula_print((yyvsp[(1) - (1)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 2820 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 2833 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListOpt\n  GraphPatternListOpt=");
  if((yyvsp[(1) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", GraphPatternList=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) =  ((yyvsp[(1) - (2)].graph_pattern) ? (yyvsp[(1) - (2)].graph_pattern) : (yyvsp[(2) - (2)].graph_pattern));
  if((yyvsp[(1) - (2)].graph_pattern) && (yyvsp[(2) - (2)].graph_pattern)) {
    (yyval.graph_pattern) = (yyvsp[(1) - (2)].graph_pattern);
    if(rasqal_graph_patterns_join((yyval.graph_pattern), (yyvsp[(2) - (2)].graph_pattern))) {
      rasqal_free_graph_pattern((yyval.graph_pattern));
      rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
      (yyval.graph_pattern) = NULL;
      YYERROR_MSG("GraphPatternListOpt: sequence join failed");
    }
    rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
  }
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after grouping graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 2870 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 2874 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = NULL;
}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 2887 "./sparql_parser.y"
    {
  rasqal_graph_pattern *formula_gp = NULL;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternList\n  GraphPatternListFilter=");
  if((yyvsp[(1) - (3)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (3)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", TriplesBlockOpt=");
  if((yyvsp[(3) - (3)].formula))
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  if((yyvsp[(3) - (3)].formula)) {
    formula_gp = rasqal_new_basic_graph_pattern_from_formula((rasqal_query*)rq, 
                                                             (yyvsp[(3) - (3)].formula));
    if(!formula_gp) {
      if((yyvsp[(1) - (3)].graph_pattern))
        rasqal_free_graph_pattern((yyvsp[(1) - (3)].graph_pattern));
      YYERROR_MSG("GraphPatternList: cannot create formula_gp");
    }
  }
  (yyval.graph_pattern) = rasqal_new_2_group_graph_pattern((rasqal_query*)rq, (yyvsp[(1) - (3)].graph_pattern), formula_gp);
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GraphPatternList: cannot create sequence");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 2935 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListFilter 1\n  GraphPatternNotTriples=");
  if((yyvsp[(1) - (1)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (1)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 2948 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListFilter 2\n  Filter=");
  if((yyvsp[(1) - (1)].expr))
    rasqal_expression_print((yyvsp[(1) - (1)].expr), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = rasqal_new_filter_graph_pattern((rasqal_query*)rq, (yyvsp[(1) - (1)].expr));
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GraphPatternListFilter 2: cannot create graph pattern");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 2982 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesBlock\n  TriplesSameSubject=");
  if((yyvsp[(1) - (3)].formula))
    rasqal_formula_print((yyvsp[(1) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", TriplesBlockOpt=");
  if((yyvsp[(3) - (3)].formula))
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif


  (yyval.formula) =  ((yyvsp[(1) - (3)].formula) ? (yyvsp[(1) - (3)].formula) : (yyvsp[(3) - (3)].formula));
  if((yyvsp[(1) - (3)].formula) && (yyvsp[(3) - (3)].formula)) {
    /* $1 and $3 are freed as necessary */
    (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (3)].formula), (yyvsp[(3) - (3)].formula));
    if(!(yyvsp[(1) - (3)].formula))
      YYERROR_MSG("TriplesBlock: formula join failed");
  }

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 3013 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 3021 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 3025 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 3029 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 3033 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 3037 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 3041 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 3045 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 3053 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "PatternElementForms 4\n  graphpattern=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = NULL;

  if((yyvsp[(2) - (2)].graph_pattern)) {
    raptor_sequence *seq;

    seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                              (raptor_data_print_handler)rasqal_graph_pattern_print);
    if(!seq) {
      rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
      YYERROR_MSG("OptionalGraphPattern 1: cannot create sequence");
    } else {
      if(raptor_sequence_push(seq, (yyvsp[(2) - (2)].graph_pattern))) {
        raptor_free_sequence(seq);
        YYERROR_MSG("OptionalGraphPattern 2: sequence push failed");
      } else {
        (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                                    seq,
                                                    RASQAL_GRAPH_PATTERN_OPERATOR_OPTIONAL);
        if(!(yyval.graph_pattern))
          YYERROR_MSG("OptionalGraphPattern: cannot create graph pattern");
      }
    }
  }
}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 3092 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphGraphPattern 2\n  varoruri=");
  rasqal_literal_print((yyvsp[(2) - (3)].literal), DEBUG_FH);
  fprintf(DEBUG_FH, ", graphpattern=");
  if((yyvsp[(3) - (3)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(3) - (3)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  if((yyvsp[(3) - (3)].graph_pattern)) {
    raptor_sequence *seq;

    seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                              (raptor_data_print_handler)rasqal_graph_pattern_print);
    if(!seq) {
      rasqal_free_graph_pattern((yyvsp[(3) - (3)].graph_pattern));
      YYERROR_MSG("GraphGraphPattern 1: cannot create sequence");
    } else {
      if(raptor_sequence_push(seq, (yyvsp[(3) - (3)].graph_pattern))) {
        raptor_free_sequence(seq);
        YYERROR_MSG("GraphGraphPattern 2: sequence push failed");
      } else {
        (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                                    seq,
                                                    RASQAL_GRAPH_PATTERN_OPERATOR_GRAPH);
        if(!(yyval.graph_pattern))
          YYERROR_MSG("GraphGraphPattern: cannot create graph pattern");
        else
          rasqal_graph_pattern_set_origin((yyval.graph_pattern), (yyvsp[(2) - (3)].literal));
      }
    }
  }


#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphGraphPattern\n  graphpattern=");
  rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  rasqal_free_literal((yyvsp[(2) - (3)].literal));
}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 3142 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = rasqal_new_single_graph_pattern((rasqal_query*)rq,
                                       RASQAL_GRAPH_PATTERN_OPERATOR_SERVICE,
                                       (yyvsp[(3) - (3)].graph_pattern));
  if((yyval.graph_pattern))
    (yyval.graph_pattern)->origin = (yyvsp[(2) - (3)].literal);
  else
    rasqal_free_literal((yyvsp[(2) - (3)].literal));
}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 3156 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = rasqal_new_single_graph_pattern((rasqal_query*)rq,
                                       RASQAL_GRAPH_PATTERN_OPERATOR_MINUS,
                                       (yyvsp[(2) - (2)].graph_pattern));
}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 3166 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(3) - (3)].graph_pattern);
  if(raptor_sequence_shift((yyval.graph_pattern)->graph_patterns, (yyvsp[(1) - (3)].graph_pattern))) {
    rasqal_free_graph_pattern((yyval.graph_pattern));
    (yyval.graph_pattern) = NULL;
    YYERROR_MSG("GroupOrUnionGraphPattern: sequence push failed");
  }

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "UnionGraphPattern\n  graphpattern=");
  rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif
}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 3181 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 3188 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (3)].graph_pattern);
  if((yyvsp[(3) - (3)].graph_pattern))
    if(raptor_sequence_push((yyval.graph_pattern)->graph_patterns, (yyvsp[(3) - (3)].graph_pattern))) {
      rasqal_free_graph_pattern((yyval.graph_pattern));
      (yyval.graph_pattern) = NULL;
      YYERROR_MSG("GroupOrUnionGraphPatternList 1: sequence push failed");
    }
}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 3198 "./sparql_parser.y"
    {
  raptor_sequence *seq;
  seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                            (raptor_data_print_handler)rasqal_graph_pattern_print);
  if(!seq) {
    if((yyvsp[(1) - (1)].graph_pattern))
      rasqal_free_graph_pattern((yyvsp[(1) - (1)].graph_pattern));
    YYERROR_MSG("GroupOrUnionGraphPatternList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].graph_pattern))
    if(raptor_sequence_push(seq, (yyvsp[(1) - (1)].graph_pattern))) {
      raptor_free_sequence(seq);
      YYERROR_MSG("GroupOrUnionGraphPatternList 2: sequence push failed");
    }
  (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                              seq,
                                              RASQAL_GRAPH_PATTERN_OPERATOR_UNION);
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GroupOrUnionGraphPatternList 1: cannot create gp");
}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 3223 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.graph_pattern) = NULL;
  if((yyvsp[(3) - (6)].variable) && (yyvsp[(5) - (6)].expr)) {
    if(sparql->experimental)
      (yyval.graph_pattern) = rasqal_new_let_graph_pattern((rasqal_query*)rq, (yyvsp[(3) - (6)].variable), (yyvsp[(5) - (6)].expr));
    else {
      sparql_syntax_error((rasqal_query*)rq,
                          "LET can only be used with LAQRS");
      YYERROR;
    }
  } else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 3244 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.graph_pattern) = NULL;
  if((yyvsp[(3) - (6)].expr) && (yyvsp[(5) - (6)].variable)) {
    if(!sparql->sparql11_query) {
      sparql_syntax_error((rasqal_query*)rq,
                          "BIND cannot be used with SPARQL 1.0");
      YYERROR;
    } else {
      (yyval.graph_pattern) = rasqal_new_let_graph_pattern((rasqal_query*)rq, (yyvsp[(5) - (6)].variable), (yyvsp[(3) - (6)].expr));
    }
  } else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 3265 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (2)].expr);
}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 3273 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 3277 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 3281 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 3288 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 3292 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 3300 "./sparql_parser.y"
    {
  raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (6)].literal));
  
  if(!(yyvsp[(4) - (6)].seq)) {
    (yyvsp[(4) - (6)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
    if(!(yyvsp[(4) - (6)].seq)) {
      rasqal_free_literal((yyvsp[(1) - (6)].literal));
      YYERROR_MSG("FunctionCall: cannot create sequence");
    }
  }

  uri = raptor_uri_copy(uri);

  if(raptor_sequence_size((yyvsp[(4) - (6)].seq)) == 1 &&
     rasqal_xsd_is_datatype_uri(((rasqal_query*)rq)->world, uri)) {
    rasqal_expression* e = (rasqal_expression*)raptor_sequence_pop((yyvsp[(4) - (6)].seq));
    (yyval.expr) = rasqal_new_cast_expression(((rasqal_query*)rq)->world, uri, e);
    if((yyval.expr))
      (yyval.expr)->flags |= (yyvsp[(3) - (6)].uinteger);
    raptor_free_sequence((yyvsp[(4) - (6)].seq));
  } else {
    unsigned int flags = 0;
    if((yyvsp[(3) - (6)].uinteger))
      flags |= 1;
    
    (yyval.expr) = rasqal_new_function_expression(((rasqal_query*)rq)->world, 
                                        uri, (yyvsp[(4) - (6)].seq), (yyvsp[(5) - (6)].seq) /* params */,
                                        flags);
    if((yyval.expr))
      (yyval.expr)->flags |= (yyvsp[(3) - (6)].uinteger);
  }
  rasqal_free_literal((yyvsp[(1) - (6)].literal));

  if(!(yyval.expr))
    YYERROR_MSG("FunctionCall: cannot create expr");
}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 3339 "./sparql_parser.y"
    {
  raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (3)].literal));
  
  if(!(yyvsp[(2) - (3)].seq)) {
    (yyvsp[(2) - (3)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
    if(!(yyvsp[(2) - (3)].seq)) {
      rasqal_free_literal((yyvsp[(1) - (3)].literal));
      YYERROR_MSG("FunctionCall: cannot create sequence");
    }
  }

  uri = raptor_uri_copy(uri);

  if(raptor_sequence_size((yyvsp[(2) - (3)].seq)) == 1 &&
     rasqal_xsd_is_datatype_uri(((rasqal_query*)rq)->world, uri)) {
    rasqal_expression* e = (rasqal_expression*)raptor_sequence_pop((yyvsp[(2) - (3)].seq));
    (yyval.expr) = rasqal_new_cast_expression(((rasqal_query*)rq)->world, uri, e);
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
  } else {
    (yyval.expr) = rasqal_new_function_expression(((rasqal_query*)rq)->world,
                                        uri, (yyvsp[(2) - (3)].seq), NULL /* params */,
                                        0 /* flags */);
  }
  rasqal_free_literal((yyvsp[(1) - (3)].literal));

  if(!(yyval.expr))
    YYERROR_MSG("FunctionCall: cannot create expr");
}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 3373 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "COALESCE cannot be used with SPARQL 1.0");
    YYERROR;
  }
  
  if(!(yyvsp[(2) - (2)].seq)) {
    (yyvsp[(2) - (2)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
    if(!(yyvsp[(2) - (2)].seq))
      YYERROR_MSG("FunctionCall: cannot create sequence");
  }

  (yyval.expr) = rasqal_new_expr_seq_expression(((rasqal_query*)rq)->world, 
                                      RASQAL_EXPR_COALESCE, (yyvsp[(2) - (2)].seq));
  if(!(yyval.expr))
    YYERROR_MSG("Coalesce: cannot create expr");
}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 3401 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (3)].seq);
}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 3408 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if((yyvsp[(3) - (3)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ArgListNoBraces 1: sequence push failed");
    }
}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 3418 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("ArgListNoBraces 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ArgListNoBraces 2: sequence push failed");
    }
}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 3434 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 3442 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (3)].seq);
}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 3450 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 3454 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                           (raptor_data_print_handler)rasqal_triple_print);
  if(!(yyval.seq)) {
    YYERROR_MSG("ConstructTriplesOpt: cannot create sequence");
  }
}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 3466 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
 
  if((yyvsp[(1) - (3)].formula)) {
    (yyval.seq) = (yyvsp[(1) - (3)].formula)->triples;
    (yyvsp[(1) - (3)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (3)].formula));
  }
  
  if((yyvsp[(3) - (3)].seq)) {
    if(!(yyval.seq)) {
      (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                               (raptor_data_print_handler)rasqal_triple_print);
      if(!(yyval.seq)) {
        raptor_free_sequence((yyvsp[(3) - (3)].seq));
        YYERROR_MSG("ConstructTriples: cannot create sequence");
      }
    }

    if(raptor_sequence_join((yyval.seq), (yyvsp[(3) - (3)].seq))) {
      raptor_free_sequence((yyvsp[(3) - (3)].seq));
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ConstructTriples: sequence join failed");
    }
    raptor_free_sequence((yyvsp[(3) - (3)].seq));
  }

 }
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 3496 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
  
  if((yyvsp[(1) - (1)].formula)) {
    (yyval.seq) = (yyvsp[(1) - (1)].formula)->triples;
    (yyvsp[(1) - (1)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (1)].formula));
  }
  
}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 3511 "./sparql_parser.y"
    {
  int i;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesSameSubject 1\n  subject=");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "\n  propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else     
    fprintf(DEBUG_FH, "\n  and empty propertyList\n");
#endif

  if((yyvsp[(2) - (2)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (2)].formula)->triples;
    rasqal_literal *subject = (yyvsp[(1) - (2)].formula)->value;
    int size = raptor_sequence_size(seq);
    
    /* non-empty property list, handle it  */
    for(i = 0; i < size; i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      t2->subject = rasqal_new_literal_from_literal(subject);
    }
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  }

  (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (2)].formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("TriplesSameSubject 1: formula join failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 3555 "./sparql_parser.y"
    {
  int i;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesSameSubject 2\n  TriplesNode=");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "\n  propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else     
    fprintf(DEBUG_FH, "\n  and empty propertyList\n");
#endif

  if((yyvsp[(2) - (2)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (2)].formula)->triples;
    rasqal_literal *subject = (yyvsp[(1) - (2)].formula)->value;
    int size = raptor_sequence_size(seq);
    
    /* non-empty property list, handle it  */
    for(i = 0; i < size; i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      t2->subject = rasqal_new_literal_from_literal(subject);
    }
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  }

  (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (2)].formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("TriplesSameSubject 2: formula join failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 3603 "./sparql_parser.y"
    {
  int i;
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "PropertyList 1\n  Verb=");
  rasqal_formula_print((yyvsp[(1) - (3)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n  ObjectList=");
  rasqal_formula_print((yyvsp[(2) - (3)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n  PropertyListTail=");
  if((yyvsp[(3) - (3)].formula) != NULL)
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
#endif
  
  if((yyvsp[(2) - (3)].formula) == NULL) {
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, " empty ObjectList not processed\n");
#endif
  } else if((yyvsp[(1) - (3)].formula) && (yyvsp[(2) - (3)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (3)].formula)->triples;
    rasqal_literal *predicate = (yyvsp[(1) - (3)].formula)->value;
    rasqal_formula *formula;
    rasqal_triple *t2;
    int size;
    
    formula = rasqal_new_formula(((rasqal_query*)rq)->world);
    if(!formula) {
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      if((yyvsp[(3) - (3)].formula))
        rasqal_free_formula((yyvsp[(3) - (3)].formula));
      YYERROR_MSG("PropertyList 1: cannot create formula");
    }
    formula->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                           (raptor_data_print_handler)rasqal_triple_print);
    if(!formula->triples) {
      rasqal_free_formula(formula);
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      if((yyvsp[(3) - (3)].formula))
        rasqal_free_formula((yyvsp[(3) - (3)].formula));
      YYERROR_MSG("PropertyList 1: cannot create sequence");
    }

    /* non-empty property list, handle it  */
    size = raptor_sequence_size(seq);
    for(i = 0; i < size; i++) {
      t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(!t2->predicate)
        t2->predicate = (rasqal_literal*)rasqal_new_literal_from_literal(predicate);
    }
  
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution ObjectList=");
    raptor_sequence_print(seq, DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif

    while(raptor_sequence_size(seq)) {
      t2 = (rasqal_triple*)raptor_sequence_unshift(seq);
      if(raptor_sequence_push(formula->triples, t2)) {
        rasqal_free_formula(formula);
        rasqal_free_formula((yyvsp[(1) - (3)].formula));
        rasqal_free_formula((yyvsp[(2) - (3)].formula));
        if((yyvsp[(3) - (3)].formula))
          rasqal_free_formula((yyvsp[(3) - (3)].formula));
        YYERROR_MSG("PropertyList 1: sequence push failed");
      }
    }

    (yyvsp[(3) - (3)].formula) = rasqal_formula_join(formula, (yyvsp[(3) - (3)].formula));
    if(!(yyvsp[(3) - (3)].formula)) {
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      YYERROR_MSG("PropertyList 1: formula join failed");
    }

#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after appending ObjectList=");
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif

    rasqal_free_formula((yyvsp[(2) - (3)].formula));
  }

  if((yyvsp[(1) - (3)].formula))
    rasqal_free_formula((yyvsp[(1) - (3)].formula));

  (yyval.formula) = (yyvsp[(3) - (3)].formula);
}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 3701 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(2) - (2)].formula);
}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 3705 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 3713 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 3717 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 3725 "./sparql_parser.y"
    {
  rasqal_formula *formula;
  rasqal_triple *triple;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "ObjectList 1\n");
  fprintf(DEBUG_FH, "  Object=\n");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "  ObjectTail=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else
    fprintf(DEBUG_FH, "  and empty ObjectTail\n");
#endif

  formula = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!formula) {
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create formula");
  }
  
  formula->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                         (raptor_data_print_handler)rasqal_triple_print);
  if(!formula->triples) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create sequence");
  }

  triple = rasqal_new_triple(NULL, NULL, (yyvsp[(1) - (2)].formula)->value);
  (yyvsp[(1) - (2)].formula)->value = NULL; /* value now owned by triple */
  if(!triple) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create triple");
  }

  if(raptor_sequence_push(formula->triples, triple)) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: sequence push failed");
  }

  (yyval.formula) = rasqal_formula_join(formula, (yyvsp[(1) - (2)].formula));
  if(!(yyval.formula)) {
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: formula join $1 failed");
  }

  (yyval.formula) = rasqal_formula_join((yyval.formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("ObjectList: formula join $2 failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  objectList is now ");
  if((yyval.formula))
    raptor_sequence_print((yyval.formula)->triples, DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 3803 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(2) - (2)].formula);
}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 3807 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 3815 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 3823 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("Verb 1: cannot create formula");
  }
  (yyval.formula)->value = (yyvsp[(1) - (1)].literal);
}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 3833 "./sparql_parser.y"
    {
  raptor_uri *uri;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "verb Verb=rdf:type (a)\n");
#endif

  uri = raptor_new_uri_for_rdf_concept(((rasqal_query*)rq)->world->raptor_world_ptr,
                                       (const unsigned char*)"type");
  if(!uri)
    YYERROR_MSG("Verb 2: uri for rdf concept type failed");
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    raptor_free_uri(uri);
    YYERROR_MSG("Verb 2: cannot create formula");
  }
  (yyval.formula)->value = rasqal_new_uri_literal(((rasqal_query*)rq)->world, uri);
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("Verb 2: cannot create uri literal");
  }
}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 3861 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 3865 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 3873 "./sparql_parser.y"
    {
  int i;
  const unsigned char *id;

  if((yyvsp[(2) - (3)].formula) == NULL) {
    (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
    if(!(yyval.formula))
      YYERROR_MSG("BlankNodePropertyList: cannot create formula");
  } else {
    (yyval.formula) = (yyvsp[(2) - (3)].formula);
    if((yyval.formula)->value) {
      rasqal_free_literal((yyval.formula)->value);
      (yyval.formula)->value = NULL;
    }
  }
  
  id = rasqal_query_generate_bnodeid((rasqal_query*)rq, NULL);
  if(!id) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("BlankNodeProperyList: cannot create bnodeid");
  }

  (yyval.formula)->value = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                        RASQAL_LITERAL_BLANK, id);
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("BlankNodePropertyList: cannot create literal");
  }

  if((yyvsp[(2) - (3)].formula) == NULL) {
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "TriplesNode\n  PropertyList=");
    rasqal_formula_print((yyval.formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  } else {
    raptor_sequence *seq = (yyvsp[(2) - (3)].formula)->triples;

    /* non-empty property list, handle it  */
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "TriplesNode\n  PropertyList=");
    raptor_sequence_print(seq, DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif

    for(i = 0; i<raptor_sequence_size(seq); i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      
      t2->subject = (rasqal_literal*)rasqal_new_literal_from_literal((yyval.formula)->value);
    }

#if RASQAL_DEBUG > 1
    fprintf(DEBUG_FH, "  after substitution formula=");
    rasqal_formula_print((yyval.formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif
  }
}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 3940 "./sparql_parser.y"
    {
  int i;
  rasqal_query* rdf_query = (rasqal_query*)rq;
  rasqal_literal* first_identifier = NULL;
  rasqal_literal* rest_identifier = NULL;
  rasqal_literal* object = NULL;
  rasqal_literal* blank = NULL;

#if RASQAL_DEBUG > 1
  char const *errmsg;
  #define YYERR_MSG_GOTO(label,msg) do { errmsg = msg; goto label; } while(0)
#else
  #define YYERR_MSG_GOTO(label,ignore) goto label
#endif

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "Collection\n  GraphNodeListNotEmpty=");
  raptor_sequence_print((yyvsp[(2) - (3)].seq), DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
#endif

  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula))
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create formula");

  (yyval.formula)->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                    (raptor_data_print_handler)rasqal_triple_print);
  if(!(yyval.formula)->triples)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create sequence");

  first_identifier = rasqal_new_uri_literal(rdf_query->world,
                                            raptor_uri_copy(rdf_query->world->rdf_first_uri));
  if(!first_identifier)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot first_identifier");
  
  rest_identifier = rasqal_new_uri_literal(rdf_query->world,
                                           raptor_uri_copy(rdf_query->world->rdf_rest_uri));
  if(!rest_identifier)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create rest_identifier");
  
  object = rasqal_new_uri_literal(rdf_query->world,
                                  raptor_uri_copy(rdf_query->world->rdf_nil_uri));
  if(!object)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create nil object");

  for(i = raptor_sequence_size((yyvsp[(2) - (3)].seq))-1; i >= 0; i--) {
    rasqal_formula* f = (rasqal_formula*)raptor_sequence_get_at((yyvsp[(2) - (3)].seq), i);
    rasqal_triple *t2;
    const unsigned char *blank_id = NULL;

    blank_id = rasqal_query_generate_bnodeid(rdf_query, NULL);
    if(!blank_id)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create bnodeid");

    blank = rasqal_new_simple_literal(((rasqal_query*)rq)->world, RASQAL_LITERAL_BLANK, blank_id);
    if(!blank)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create bnode");

    /* Move existing formula triples */
    if(f->triples)
      if(raptor_sequence_join((yyval.formula)->triples, f->triples))
        YYERR_MSG_GOTO(err_Collection, "Collection: sequence join failed");

    /* add new triples we needed */
    t2 = rasqal_new_triple(rasqal_new_literal_from_literal(blank),
                           rasqal_new_literal_from_literal(first_identifier),
                           rasqal_new_literal_from_literal(f->value));
    if(!t2)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple");

    if(raptor_sequence_push((yyval.formula)->triples, t2))
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple");

    t2 = rasqal_new_triple(rasqal_new_literal_from_literal(blank),
                           rasqal_new_literal_from_literal(rest_identifier),
                           rasqal_new_literal_from_literal(object));
    if(!t2)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple 2");

    if(raptor_sequence_push((yyval.formula)->triples, t2))
      YYERR_MSG_GOTO(err_Collection, "Collection: sequence push 2 failed");

    rasqal_free_literal(object);
    object=blank;
    blank = NULL;
  }

  /* free sequence of formulas just processed */
  raptor_free_sequence((yyvsp[(2) - (3)].seq));
  
  (yyval.formula)->value=object;
  
#if RASQAL_DEBUG > 1
  fprintf(DEBUG_FH, "  after substitution collection=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif

  rasqal_free_literal(first_identifier);
  rasqal_free_literal(rest_identifier);

  break; /* success */

  err_Collection:
  
  if(blank)
    rasqal_free_literal(blank);
  if(object)
    rasqal_free_literal(object);
  if(rest_identifier)
    rasqal_free_literal(rest_identifier);
  if(first_identifier)
    rasqal_free_literal(first_identifier);
  if((yyvsp[(2) - (3)].seq))
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
  if((yyval.formula)) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
  }
  YYERROR_MSG(errmsg);
}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 4067 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  char const *errmsg;

  fprintf(DEBUG_FH, "GraphNodeListNotEmpty 1\n");
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "  GraphNode=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else  
    fprintf(DEBUG_FH, "  and empty GraphNode\n");
  if((yyvsp[(1) - (2)].seq)) {
    fprintf(DEBUG_FH, "  GraphNodeListNotEmpty=");
    raptor_sequence_print((yyvsp[(1) - (2)].seq), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else
    fprintf(DEBUG_FH, "  and empty GraphNodeListNotEmpty\n");
#endif

  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(!(yyval.seq)) {
    (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_formula,
                             (raptor_data_print_handler)rasqal_formula_print);
    if(!(yyval.seq))
      YYERR_MSG_GOTO(err_GraphNodeListNotEmpty,
                     "GraphNodeListNotEmpty: cannot create formula");
  }
  
  if((yyvsp[(2) - (2)].formula)) {
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].formula))) {
      YYERR_MSG_GOTO(err_GraphNodeListNotEmpty,
                     "GraphNodeListNotEmpty 1: sequence push failed");
    }
    (yyvsp[(2) - (2)].formula) = NULL;
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  itemList is now ");
    raptor_sequence_print((yyval.seq), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif
  }

  break; /* success */

  err_GraphNodeListNotEmpty:
  if((yyvsp[(2) - (2)].formula))
    rasqal_free_formula((yyvsp[(2) - (2)].formula));
  if((yyval.seq)) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
  }
  YYERROR_MSG(errmsg);
}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 4120 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphNodeListNotEmpty 2\n");
  if((yyvsp[(1) - (1)].formula)) {
    fprintf(DEBUG_FH, "  GraphNode=");
    rasqal_formula_print((yyvsp[(1) - (1)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else  
    fprintf(DEBUG_FH, "  and empty GraphNode\n");
#endif

  if(!(yyvsp[(1) - (1)].formula))
    (yyval.seq) = NULL;
  else {
    (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_formula,
                             (raptor_data_print_handler)rasqal_formula_print);
    if(!(yyval.seq)) {
      rasqal_free_formula((yyvsp[(1) - (1)].formula));
      YYERROR_MSG("GraphNodeListNotEmpty 2: cannot create sequence");
    }
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].formula))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GraphNodeListNotEmpty 2: sequence push failed");
    }
  }
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  GraphNodeListNotEmpty is now ");
  raptor_sequence_print((yyval.seq), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 4157 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 4161 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 4169 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula))
    YYERROR_MSG("VarOrTerm 1: cannot create formula");
  (yyval.formula)->value = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("VarOrTerm 1: cannot create literal");
  }
}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 4181 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("VarOrTerm 2: cannot create formula");
  }
  (yyval.formula)->value = (yyvsp[(1) - (1)].literal);
}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 4194 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!(yyval.literal))
    YYERROR_MSG("VarOrIRIref: cannot create literal");
}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 4200 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 4208 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 4212 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 4219 "./sparql_parser.y"
    {
  (yyval.variable) = rasqal_variables_table_add(((rasqal_query*)rq)->vars_table,
                                  RASQAL_VARIABLE_TYPE_NORMAL, (yyvsp[(1) - (1)].name), NULL);
  if(!(yyval.variable))
    YYERROR_MSG("VarName: cannot create var");
}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 4230 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 4234 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 4238 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(1) - (1)].variable);
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "... AS varname is deprecated LAQRS syntax, use ... AS ?varname");
}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 4248 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 4252 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 4256 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 4260 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 4264 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 4268 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, 
                              raptor_uri_copy(((rasqal_query*)rq)->world->rdf_nil_uri));
  if(!(yyval.literal))
    YYERROR_MSG("GraphTerm: cannot create literal");
}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 4278 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 4286 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_OR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("ConditionalOrExpression: cannot create expr");
}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 4293 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 4301 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_AND, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("ConditionalAndExpression: cannot create expr");
;
}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 4309 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 4318 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_EQ, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 1: cannot create expr");
}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 4325 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_NEQ, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 2: cannot create expr");
}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 4332 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 3: cannot create expr");
}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 4339 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_GT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 4: cannot create expr");
}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 4346 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 5: cannot create expr");
}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 4353 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_GE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 6: cannot create expr");
}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 4360 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_set_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_IN, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].seq));
}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 4365 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_set_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_NOT_IN, (yyvsp[(1) - (4)].expr), (yyvsp[(4) - (4)].seq));
}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 4370 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 4379 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 1: cannot create expr");
}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 4386 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_MINUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 2: cannot create expr");
}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 4393 "./sparql_parser.y"
    {
  rasqal_expression *e;
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].literal));
  if(!e) {
    rasqal_free_expression((yyvsp[(1) - (2)].expr));
    YYERROR_MSG("AdditiveExpression 3: cannot create expr");
  }
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (2)].expr), e);
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 4: cannot create expr");
}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 4406 "./sparql_parser.y"
    {
  rasqal_expression *e;
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].literal));
  if(!e) {
    rasqal_free_expression((yyvsp[(1) - (2)].expr));
    YYERROR_MSG("AdditiveExpression 5: cannot create expr");
  }
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (2)].expr), e);
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 6: cannot create expr");
}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 4419 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 4426 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STAR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("MultiplicativeExpression 1: cannot create expr");
}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 4433 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SLASH, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("MultiplicativeExpression 2: cannot create expr");
}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 4440 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 4448 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_BANG, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("UnaryExpression 1: cannot create expr");
}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 4455 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (2)].expr);
}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 4459 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_UMINUS, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("UnaryExpression 3: cannot create expr");
}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 4466 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 4480 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 4484 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 4488 "./sparql_parser.y"
    {
  /* Grammar has IRIrefOrFunction here which is "IRIref ArgList?"
   * and essentially shorthand for FunctionCall | IRIref.  The Rasqal
   * SPARQL lexer distinguishes these for us with IRIrefBrace.
   * IRIref is covered below by GraphTerm.
   */
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 4497 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].literal));
  if(!(yyval.expr))
    YYERROR_MSG("PrimaryExpression 4: cannot create expr");
}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 4503 "./sparql_parser.y"
    {
  rasqal_literal *l;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("PrimaryExpression 5: cannot create literal");
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!(yyval.expr))
    YYERROR_MSG("PrimaryExpression 5: cannot create expr");
}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 4513 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 4521 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (3)].expr);
}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 4529 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STR, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 1: cannot create expr");
}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 4536 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LANG, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 2: cannot create expr");
}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 4543 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LANGMATCHES, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 3: cannot create expr");
}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 4550 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_DATATYPE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 4: cannot create expr");
}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 4557 "./sparql_parser.y"
    {
  rasqal_literal *l;
  rasqal_expression *e;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(3) - (4)].variable));
  if(!l)
    YYERROR_MSG("BuiltInCall 5: cannot create literal");
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!e)
    YYERROR_MSG("BuiltInCall 6: cannot create literal expr");
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_BOUND, e);
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7: cannot create expr");
}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 4572 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_IRI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7a: cannot create expr");
}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 4579 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_IRI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7b: cannot create expr");
}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 4586 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_BNODE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7c: cannot create expr");
}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 4593 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_BNODE, NULL);
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7d: cannot create expr");
}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 4600 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_0op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_RAND);
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7e: cannot create expr");
}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 4607 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_ABS, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7f: cannot create expr");
}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 4614 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_CEIL, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7g: cannot create expr");
}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 4621 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_FLOOR, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7h: cannot create expr");
}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 4628 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_ROUND, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7i: cannot create expr");
}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 4635 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_MD5, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7j: cannot create expr");
}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 4642 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_SHA1, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7k: cannot create expr");
}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 4649 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_SHA224, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7l: cannot create expr");
}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 4656 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_SHA256, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7m: cannot create expr");
}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 4663 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_SHA384, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7n: cannot create expr");
}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 4670 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_SHA512, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7o: cannot create expr");
}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 4677 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 4681 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 4685 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_IF, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7e: cannot create expr");
}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 4692 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRLANG, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7f: cannot create expr");
}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 4699 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRDT, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7g: cannot create expr");
}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 4706 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SAMETERM, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 8: cannot create expr");
}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 4713 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISURI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 9: cannot create expr");
}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 4720 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISBLANK, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 10: cannot create expr");
}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 4727 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISLITERAL, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 11: cannot create expr");
}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 4734 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISNUMERIC, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 12: cannot create expr");
}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 4741 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 4745 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 4749 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 4756 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRLEN, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create STRLEN() expr");
}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 4763 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SUBSTR, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr), NULL);
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create SUBSTR() expr");
}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 4770 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SUBSTR, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create SUBSTR() expr");
}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 4777 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_UCASE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create UCASE() expr");
}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 4784 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LCASE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create LCASE() expr");
}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 4791 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRSTARTS, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create STRSTARTS() expr");
}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 4798 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRENDS, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create STRENDS() expr");
}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 4805 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_CONTAINS, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create YEAR expr");
}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 4812 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ENCODE_FOR_URI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create ENCODE_FOR_URI() expr");
}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 4819 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_expr_seq_expression(((rasqal_query*)rq)->world, 
                                      RASQAL_EXPR_CONCAT, (yyvsp[(3) - (4)].seq));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create CONCAT() expr");
}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 4830 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_REGEX, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr), NULL);
  if(!(yyval.expr))
    YYERROR_MSG("RegexExpression 1: cannot create expr");
}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 4837 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_REGEX, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RegexExpression 2: cannot create expr");
}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 4848 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_YEAR, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create YEAR expr");
}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 4855 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_MONTH, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create MONTH expr");
}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 4862 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_DAY, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create DAY expr");
}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 4869 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_HOURS, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create HOURS expr");
}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 4876 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_MINUTES, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create MINUTES expr");
}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 4883 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SECONDS, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create SECONDS expr");
}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 4890 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_TIMEZONE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create TIMEZONE expr");
}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 4897 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_TZ, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create TZ expr");
}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 4908 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(sparql->experimental) {
    (yyval.expr) = rasqal_new_0op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_CURRENT_DATETIME);
    if(!(yyval.expr))
      YYERROR_MSG("DatetimeExtensions: cannot create CURRENT_DATETIME() expr");
  } else {
    sparql_syntax_error((rasqal_query*)rq, 
                        "CURRENT_DATETIME() can only used with LAQRS");
    YYERROR;
  }
}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 4925 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);
  
  (yyval.expr) = NULL;
  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "NOW() cannot be used with SPARQL 1.0");
    YYERROR;
  }
  
  (yyval.expr) = rasqal_new_0op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_NOW);
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeExtensions: cannot create NOW()");

}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 4943 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(sparql->experimental) {
    (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_FROM_UNIXTIME, (yyvsp[(3) - (4)].expr));
    if(!(yyval.expr))
      YYERROR_MSG("DatetimeExtensions: cannot create FROM_UNIXTIME() expr");
  } else {
    sparql_syntax_error((rasqal_query*)rq, 
                        "FROM_UNIXTIME() can only used with LAQRS");
    YYERROR;
  }
  
}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 4961 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(sparql->experimental) {
    (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_TO_UNIXTIME, (yyvsp[(3) - (4)].expr));
    if(!(yyval.expr))
      YYERROR_MSG("DatetimeExtensions: cannot create TO_UNIXTIME() expr");
  } else {
    sparql_syntax_error((rasqal_query*)rq, 
                        "TO_UNIXTIME() can only used with LAQRS");
    YYERROR;
  }
  
}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 4986 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].uri));
  if(!(yyval.literal))
    YYERROR_MSG("IRIrefBrace 1: cannot create literal");
}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 4992 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_QNAME, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("IRIrefBrace 2: cannot create literal");
  if(rasqal_literal_expand_qname((rasqal_query*)rq, (yyval.literal))) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", (yyvsp[(1) - (1)].name));
    rasqal_free_literal((yyval.literal));
    (yyval.literal) = NULL;
    YYERROR_MSG("IRIrefBrace 2: cannot expand qname");
  }
}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 5012 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 5016 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 5020 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 5027 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 5031 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 5035 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 5043 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 5047 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 5051 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 5059 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 5063 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 5067 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 5079 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].uri));
  if(!(yyval.literal))
    YYERROR_MSG("IRIref 1: cannot create literal");
}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 5085 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_QNAME, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("IRIref 2: cannot create literal");
  if(rasqal_literal_expand_qname((rasqal_query*)rq, (yyval.literal))) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", (yyvsp[(1) - (1)].name));
    rasqal_free_literal((yyval.literal));
    (yyval.literal) = NULL;
    YYERROR_MSG("IRIrefBrace 2: cannot expand qname");
  }
}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 5105 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_BLANK, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("BlankNode 1: cannot create literal");
}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 5111 "./sparql_parser.y"
    {
  const unsigned char *id;
  id = rasqal_query_generate_bnodeid((rasqal_query*)rq, NULL);
  if(!id)
    YYERROR_MSG("BlankNode 2: cannot create bnodeid");
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_BLANK, id);
  if(!(yyval.literal))
    YYERROR_MSG("BlankNode 2: cannot create literal");
}
    break;



/* Line 1455 of yacc.c  */
#line 10129 "sparql_parser.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 5130 "./sparql_parser.y"



/* Support functions */


/* This is declared in sparql_lexer.h but never used, so we always get
 * a warning unless this dummy code is here.  Used once below in an error case.
 */
static int yy_init_globals (yyscan_t yyscanner ) { return 0; }


/**
 * rasqal_sparql_query_language_init - Initialise the SPARQL query language parser
 *
 * Return value: non 0 on failure
 **/
static int
rasqal_sparql_query_language_init(rasqal_query* rdf_query, const char *name)
{
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rdf_query->context;

  rdf_query->compare_flags = RASQAL_COMPARE_XQUERY;

  /* All the sparql query families support this */
  rqe->sparql10 = 1;
  rqe->sparql_query = 1;

  /* SPARQL 1.1 */
  if(!strncmp(name, "sparql11", 8) || !strcmp(name, "laqrs")) {
    rqe->sparql11_query = 1;
    rqe->sparql11_aggregates = 1;
    rqe->sparql11_property_paths = 1;
    rqe->sparql11_update = 1;
  }

  if(!strcmp(name, "sparql11-query")) {
    /* No update if SPARQL 1.1 query */
    rqe->sparql11_update = 0;
  }
  
  if(!strcmp(name, "sparql11-update")) {
    /* No query if SPARQL 1.1 update */
    rqe->sparql_query = 0;
    rqe->sparql11_query = 0;
  }
  
  /* LAQRS for experiments */
  if(!strcmp(name, "laqrs"))
    rqe->experimental = 1;

  return 0;
}


/**
 * rasqal_sparql_query_language_terminate - Free the SPARQL query language parser
 *
 * Return value: non 0 on failure
 **/
static void
rasqal_sparql_query_language_terminate(rasqal_query* rdf_query)
{
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)rdf_query->context;

  if(sparql && sparql->scanner_set) {
    sparql_lexer_lex_destroy(sparql->scanner);
    sparql->scanner_set = 0;
  }

}


static int
rasqal_sparql_query_language_prepare(rasqal_query* rdf_query)
{
  /* rasqal_sparql_query_language* sparql = (rasqal_sparql_query_language*)rdf_query->context; */
  int rc;
  
  if(!rdf_query->query_string)
    return 1;
  
  rc=sparql_parse(rdf_query);
  if(rc)
    return rc;

  /* FIXME - should check remaining query parts  */
  if(rasqal_sequence_has_qname(rdf_query->triples) ||
     rasqal_sequence_has_qname(rdf_query->constructs) ||
     rasqal_query_constraints_has_qname(rdf_query)) {
    sparql_query_error(rdf_query, "SPARQL query has unexpanded QNames");
    return 1;
  }

  /* SPARQL: Turn [] into anonymous variables */
  if(rasqal_query_build_anonymous_variables(rdf_query))
    return 1;
  
  /* SPARQL: Expand 'SELECT *' */
  if(rasqal_query_expand_wildcards(rdf_query))
    return 1;
  
  return 0;
}


static int
sparql_parse(rasqal_query* rq)
{
  rasqal_sparql_query_language* rqe;
  raptor_locator *locator=&rq->locator;
  void *buffer;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(!rq->query_string)
    return yy_init_globals(NULL); /* 0 but a way to use yy_init_globals */

  locator->line = 1;
  locator->column = -1; /* No column info */
  locator->byte = -1; /* No bytes info */

#if RASQAL_DEBUG > 2
  sparql_parser_debug = 1;
#endif

  rqe->lineno = 1;

  if(sparql_lexer_lex_init(&rqe->scanner))
    return 1;
  rqe->scanner_set = 1;

  sparql_lexer_set_extra(((rasqal_query*)rq), rqe->scanner);

  buffer = sparql_lexer__scan_buffer((char*)rq->query_string,
                                     rq->query_string_length, rqe->scanner);

  rqe->error_count = 0;

  sparql_parser_parse(rq);

  sparql_lexer_lex_destroy(rqe->scanner);
  rqe->scanner_set = 0;

  /* Parsing failed */
  if(rq->failed)
    return 1;
  
  return 0;
}


static void
sparql_query_error(rasqal_query *rq, const char *msg)
{
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column = sparql_lexer_get_column(yyscanner);*/
#endif

  rq->failed = 1;
  rasqal_log_error_simple(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                          &rq->locator, "%s", msg);
}


static void
sparql_query_error_full(rasqal_query *rq, const char *message, ...)
{
  va_list arguments;
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column = sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);

  rq->failed = 1;
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                           &rq->locator, message, arguments);

  va_end(arguments);
}


int
sparql_syntax_error(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_language *rqe;
  va_list arguments;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return 0;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rp->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rq->failed = 1;
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                           &rq->locator, message, arguments);
  va_end(arguments);

  return 0;
}


int
sparql_syntax_warning(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_language *rqe;
  va_list arguments;

  if(RASQAL_WARNING_LEVEL_QUERY_SYNTAX < rq->world->warning_level)
    return 0;
  
  rqe = (rasqal_sparql_query_language*)rq->context;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_WARN,
                           &rq->locator, message, arguments);
  va_end(arguments);

  return 0;
}


static int
rasqal_sparql_query_language_iostream_write_escaped_counted_string(rasqal_query* query,
                                                                   raptor_iostream* iostr,
                                                                   const unsigned char* string,
                                                                   size_t len)
{
  const char delim = '"';
  
  raptor_iostream_write_byte(delim, iostr);
  if(raptor_string_ntriples_write(string, len, delim, iostr))
    return 1;
  
  raptor_iostream_write_byte(delim, iostr);

  return 0;
}


static const char* const sparql_names[] = { "sparql", "sparql10", NULL};

static const char* const sparql_uri_strings[] = {
  "http://www.w3.org/TR/rdf-sparql-query/",
  NULL
};

static const raptor_type_q sparql_types[] = {
  { "application/sparql", 18, 10}, 
  { NULL, 0, 0}
};


static int
rasqal_sparql_query_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = sparql_names;

  factory->desc.mime_types = sparql_types;

  factory->desc.label = "SPARQL 1.0 W3C RDF Query Language";

  factory->desc.uri_strings = sparql_uri_strings;

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


int
rasqal_init_query_language_sparql(rasqal_world* world)
{
  return !rasqal_query_language_register_factory(world,
                                                 &rasqal_sparql_query_language_register_factory);
}


static const char* const sparql11_names[] = { "sparql11", NULL };

static const raptor_type_q sparql11_types[] = {
  { NULL, 0, 0}
};


static int
rasqal_sparql11_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = sparql11_names;

  factory->desc.mime_types = sparql11_types;

  factory->desc.label = "SPARQL 1.1 (DRAFT) Query and Update Languages";

  /* What URI describes Query and Update languages? */
  factory->desc.uri_strings = NULL;

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


static const char* const sparql11_query_names[] = { "sparql11-query", NULL };

static const char* const sparql11_uri_strings[] = {
  "http://www.w3.org/TR/2010/WD-sparql11-query-20101014/",
  NULL
};

static const raptor_type_q sparql11_query_types[] = {
  { NULL, 0, 0}
};


static int
rasqal_sparql11_query_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = sparql11_query_names;

  factory->desc.mime_types = sparql11_query_types;

  factory->desc.label = "SPARQL 1.1 (DRAFT) Query Language";

  factory->desc.uri_strings = sparql11_uri_strings;

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


static const char* const sparql11_update_names[] = { "sparql11-update", NULL };

static const char* const sparql11_update_uri_strings[] = {
  "http://www.w3.org/TR/2010/WD-sparql11-update-20101014/",
  NULL
};

static const raptor_type_q sparql11_update_types[] = {
  { NULL, 0, 0}
};


static int
rasqal_sparql11_update_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = sparql11_update_names;

  factory->desc.mime_types = sparql11_update_types;

  factory->desc.label = "SPARQL 1.1 (DRAFT) Update Language";

  factory->desc.uri_strings = sparql11_update_uri_strings;

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


int
rasqal_init_query_language_sparql11(rasqal_world* world)
{
  if(!rasqal_query_language_register_factory(world,
                                             &rasqal_sparql11_language_register_factory))
    return 1;
  
  if(!rasqal_query_language_register_factory(world,
                                             &rasqal_sparql11_query_language_register_factory))
    return 1;
  
  if(!rasqal_query_language_register_factory(world,
                                             &rasqal_sparql11_update_language_register_factory))
    return 1;
  
  return 0;
}


static const char* const laqrs_names[] = { "laqrs", NULL};

static const raptor_type_q laqrs_types[] = {
  { NULL, 0, 0}
};


static int
rasqal_laqrs_query_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = laqrs_names;

  factory->desc.mime_types = laqrs_types;

  factory->desc.label = "LAQRS adds to Querying RDF in SPARQL";

  factory->desc.uri_strings = NULL;

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


int
rasqal_init_query_language_laqrs(rasqal_world* world)
{
  return !rasqal_query_language_register_factory(world,
                                                 &rasqal_laqrs_query_language_register_factory);
}


#ifdef STANDALONE
#include <stdio.h>
#include <locale.h>
#ifdef HAVE_GETOPT_H
#include <getopt.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifndef HAVE_GETOPT
#include <rasqal_getopt.h>
#endif

#ifdef NEED_OPTIND_DECLARATION
extern int optind;
extern char *optarg;
#endif

#define GETOPT_STRING "di:"

#define SPARQL_FILE_BUF_SIZE 4096

int
main(int argc, char *argv[]) 
{
  const char *program = rasqal_basename(argv[0]);
  char query_string[SPARQL_FILE_BUF_SIZE];
  rasqal_query *query;
  FILE *fh;
  int rc;
  const char *filename = NULL;
  raptor_uri* base_uri = NULL;
  unsigned char *uri_string = NULL;
  const char* query_language = "sparql";
  int usage = 0;
  rasqal_world *world;
  
  world = rasqal_new_world();
  if(!world || rasqal_world_open(world))
    exit(1);

  filename = getenv("SPARQL_QUERY_FILE");
    
  while(!usage) {
    int c = getopt (argc, argv, GETOPT_STRING);

    if (c == -1)
      break;

    switch (c) {
      case 0:
      case '?': /* getopt() - unknown option */
        usage = 1;
        break;
        
      case 'd':
#if RASQAL_DEBUG > 2
        sparql_parser_debug = 1;
#endif
        break;
  
      case 'i':
        if(optarg) {
          if(rasqal_language_name_check(world, optarg)) {
            query_language = optarg;
          } else {
            fprintf(stderr, "%s: Unknown query language '%s'\n",
                    program, optarg);
            usage = 1;
          }
        }
        break;
    }
  }

  if(!filename) {
    if((argc-optind) != 1) {
      fprintf(stderr, "%s: Too many arguments.\n", program);
      usage = 1;
    } else
      filename = argv[optind];
  }
  
  if(usage) {
    fprintf(stderr, "SPARQL/LAQRS parser test for Rasqal %s\n", 
            rasqal_version_string);
    fprintf(stderr, "USAGE: %s [OPTIONS] SPARQL-QUERY-FILE\n", program);
    fprintf(stderr, "OPTIONS:\n");
#if RASQAL_DEBUG > 2
    fprintf(stderr, " -d           Bison parser debugging\n");
#endif
    fprintf(stderr, " -i LANGUAGE  Set query language\n");
    rc = 1;
    goto tidy;
  }


 fh = fopen(filename, "r");
 if(!fh) {
   fprintf(stderr, "%s: Cannot open file %s - %s\n", program, filename,
           strerror(errno));
   rc = 1;
   goto tidy;
 }
 
  memset(query_string, 0, SPARQL_FILE_BUF_SIZE);
  rc=fread(query_string, SPARQL_FILE_BUF_SIZE, 1, fh);
  if(rc < SPARQL_FILE_BUF_SIZE) {
    if(ferror(fh)) {
      fprintf(stderr, "%s: file '%s' read failed - %s\n",
              program, filename, strerror(errno));
      fclose(fh);
      rc = 1;
      goto tidy;
    }
  }
  
  fclose(fh);

  query = rasqal_new_query(world, query_language, NULL);
  rc = 1;
  if(query) {
    uri_string = raptor_uri_filename_to_uri_string(filename);

    if(uri_string) {
      base_uri = raptor_new_uri(world->raptor_world_ptr, uri_string);

      if(base_uri) {
        rc = rasqal_query_prepare(query, (const unsigned char*)query_string, 
                                  base_uri);

        if(!rc)
          rasqal_query_print(query, stdout);
      }
    }
  }

  tidy:
  if(query)
    rasqal_free_query(query);

  if(base_uri)
    raptor_free_uri(base_uri);

  if(uri_string)
    raptor_free_memory(uri_string);

  if(world)
    rasqal_free_world(world);

  return rc;
}
#endif

